using OrdinaryDiffEqExponentialRK, Test, Random, LinearAlgebra, SparseArrays
using OrdinaryDiffEqTsit5

let N = 20
    Random.seed!(0)
    u0 = normalize(randn(N))
    dd = -2 * ones(N)
    du = ones(N - 1)
    A = diagm(-1 => du, 0 => dd, 1 => du)
    _f = (u, p, t) -> A * u - u .^ 3
    _f_ip = (du, u, p, t) -> (mul!(du, A, u); du .-= u .^ 3)
    _jac = (J, u, p, t) -> A - 3 * diagm(0 => u .^ 2)
    _jac_ip! = (J, u, p, t) -> begin
        copyto!(J, A)
        @inbounds for i in 1:N
            J[i, i] -= 3 * u[i]^2
        end
    end
    # f = ODEFunction(_f; jac=_jac)
    # f_ip = ODEFunction(_f_ip; jac=_jac_ip!, jac_prototype=zeros(N,N))
    jac_prototype = MatrixOperator(zeros(N, N); update_func! = _jac_ip!, update_func = _jac)
    f = ODEFunction(_f; jac_prototype = jac_prototype)
    f_ip = ODEFunction(_f_ip; jac_prototype = jac_prototype)
    prob = ODEProblem(f, u0, (0.0, 1.0))
    prob_ip = ODEProblem(f_ip, u0, (0.0, 1.0))

    @testset "Classical ExpRK - Low Order" begin
        dt = 0.01
        tol = 1.0e-3
        Algs = [LawsonEuler, NorsettEuler, ETDRK2]
        for Alg in Algs
            sol = solve(prob, Alg(krylov = true, m = 20); dt = dt, reltol = tol)
            sol_ref = solve(prob, Tsit5(); reltol = tol)
            @test isapprox(sol(1.0), sol_ref(1.0); rtol = tol)

            sol = solve(prob_ip, Alg(krylov = true, m = 20); dt = dt, reltol = tol)
            sol_ref = solve(prob_ip, Tsit5(); reltol = tol)
            @test isapprox(sol(1.0), sol_ref(1.0); rtol = tol)

            println(Alg) # prevent Travis hanging
        end
    end

    @testset "Classical ExpRK - High Order" begin
        dt = 0.05
        tol = 1.0e-5
        Algs = [ETDRK3, ETDRK4, HochOst4]
        for Alg in Algs
            sol = solve(prob, Alg(krylov = true, m = 20); dt = dt, reltol = tol)
            sol_ref = solve(prob, Tsit5(); reltol = tol)
            @test isapprox(sol(1.0), sol_ref(1.0); rtol = tol)

            sol = solve(prob_ip, Alg(krylov = true, m = 20); dt = dt, reltol = tol)
            sol_ref = solve(prob_ip, Tsit5(); reltol = tol)
            @test isapprox(sol(1.0), sol_ref(1.0); rtol = tol)

            println(Alg) # prevent Travis hanging
        end
    end

    @testset "EPIRK" begin
        dt = 0.05
        tol = 1.0e-5
        Algs = [Exp4, EPIRK4s3A, EPIRK4s3B, EXPRB53s3, EPIRK5P1, EPIRK5P2]
        for Alg in Algs
            sol = solve(prob, Alg(); dt = dt, reltol = tol)
            sol_ref = solve(prob, Tsit5(); reltol = tol)
            @test isapprox(sol(1.0), sol_ref(1.0); rtol = tol)

            sol = solve(prob_ip, Alg(); dt = dt, reltol = tol)
            sol_ref = solve(prob_ip, Tsit5(); reltol = tol)
            @test isapprox(sol(1.0), sol_ref(1.0); rtol = tol)
            println(Alg) # prevent Travis hanging
        end

        sol = solve(prob, EPIRK5s3(); dt = dt, reltol = tol)
        sol_ref = solve(prob, Tsit5(); reltol = tol)
        @test_broken isapprox(sol(1.0), sol_ref(1.0); rtol = tol)

        sol = solve(prob_ip, EPIRK5s3(); dt = dt, reltol = tol)
        sol_ref = solve(prob_ip, Tsit5(); reltol = tol)
        @test_broken isapprox(sol(1.0), sol_ref(1.0); rtol = tol)
        println(EPIRK5s3) # prevent Travis hanging
    end

    @testset "Adaptive exponential Rosenbrock" begin
        # Regression tests adapted from ode_dense_tests.jl
        interp_points = 0.0:(1 / 16):1.0
        interp_results = [zeros(N) for _ in 1:length(interp_points)]
        function regression_test(prob, alg, tol)
            sol1 = solve(prob, alg, dt = 1 / 4, dense = true, adaptive = true)
            sol1(interp_results, interp_points)
            sol2 = solve(prob, alg, dt = 1 / 16, dense = true, adaptive = false)
            for i in eachindex(sol2)
                err = maximum(abs.(sol2.u[i] - interp_results[i]))
                @test err < tol
            end
        end

        println("Exprb32, out-of-place")
        regression_test(prob, Exprb32(m = N), 3.0e-4)
        println("Exprb32, inplace")
        regression_test(prob_ip, Exprb32(m = N), 3.0e-4)
        println("Exprb43, out-of-place")
        regression_test(prob, Exprb43(m = N), 3.0e-4)
        println("Exprb43, inplace")
        regression_test(prob_ip, Exprb43(m = N), 3.0e-4)
    end
end

@testset "ExpRK with custom jacobian" begin
    N = 10
    # Sparse Jacobian
    Random.seed!(0)
    u0 = normalize(randn(N))
    dd = -2 * ones(N)
    du = ones(N - 1)
    A = spdiagm(-1 => du, 0 => dd, 1 => du)
    f = (u, p, t) -> A * u
    exp_fun = ODEFunction(
        f;
        jac = (u, p, t) -> A,
        analytic = (u, p, t) -> exp(t * Matrix(A)) * u
    )
    prob = ODEProblem(exp_fun, u0, (0.0, 1.0))
    sol = solve(prob, LawsonEuler(krylov = true, m = N); dt = 0.1)
    @test sol(1.0) ≈ exp_fun.analytic(u0, nothing, 1.0)
end

@testset "ExpRK with default jacobian" begin
    N = 10
    Random.seed!(0)
    u0 = normalize(randn(N))
    dd = -2 * ones(N)
    du = ones(N - 1)
    A = diagm(-1 => du, 0 => dd, 1 => du)
    f = (du, u, p, t) -> mul!(du, A, u)
    jac = (J, u, p, t) -> (J .= A; nothing)
    exp_fun = ODEFunction(f; jac = jac, analytic = (u, p, t) -> exp(t * A) * u)
    prob = ODEProblem(exp_fun, u0, (0.0, 1.0))
    sol = solve(prob, LawsonEuler(krylov = true, m = N); dt = 0.1)
    @test sol(1.0) ≈ exp_fun.analytic(u0, nothing, 1.0)
end

using Pkg
Pkg.add("JET")

import OrdinaryDiffEqExponentialRK
using JET

@testset "JET Tests" begin
    test_package(
        OrdinaryDiffEqExponentialRK, target_modules = (OrdinaryDiffEqExponentialRK,), mode = :typo
    )
end

# Helper function to compute the G_nj factors for the classical ExpRK methods
@inline _compute_nl(f::SplitFunction, u, p, t, A) = f.f2(u, p, t)
@inline _compute_nl(f, u, p, t, A) = f(u, p, t) - A * u
@inline _compute_nl!(G, f::SplitFunction, u, p, t, A, Au_cache) = f.f2(G, u, p, t)
@inline function _compute_nl!(G, f, u, p, t, A, Au_cache)
    f(G, u, p, t)
    mul!(Au_cache, A, u)
    return G .-= Au_cache
end

##########################################
# Common initializers for ExpRK integrators
function initialize!(integrator, cache::ExpRKConstantCache)
    # Pre-start fsal
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.fsallast = zero(integrator.fsalfirst)

    # Initialize interpolation derivatives
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end
function initialize!(integrator, cache::ExpRKCache)
    # Pre-start fsal
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Initialize interpolation derivatives
    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

###########################################
# Classical ExpRK integrators
function perform_step!(integrator, cache::LawsonEulerConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    A = isa(f, SplitFunction) ? f.f1.f : calc_J(integrator, cache) # get linear operator
    alg = unwrap_alg(integrator, true)

    nl = _compute_nl(f, uprev, p, t, A)
    if isa(f, SplitFunction)
        integrator.stats.nf2 += 1
    else
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
    @muladd v = uprev + dt * nl
    if alg.krylov
        u = expv(
            dt, A, v; m = min(alg.m, size(A, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop
        )
    else
        exphA = cache.ops
        u = exphA * v
    end

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::LawsonEulerCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, rtmp, G, J, exphA, KsCache) = cache
    A = isa(f, SplitFunction) ? f.f1.f : (calc_J!(J, integrator, cache); J) # get linear operator
    alg = unwrap_alg(integrator, true)

    _compute_nl!(G, f, uprev, p, t, A, rtmp)
    if isa(f, SplitFunction)
        integrator.stats.nf2 += 1
    else
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
    @muladd @.. broadcast = false tmp = uprev + dt * G
    if alg.krylov
        Ks, expv_cache = KsCache
        arnoldi!(
            Ks, A, tmp; m = min(alg.m, size(A, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop
        )
        expv!(u, dt, Ks; cache = expv_cache)
    else
        mul!(u, exphA, tmp)
    end

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

function perform_step!(integrator, cache::NorsettEulerConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    A = isa(f, SplitFunction) ? f.f1.f : calc_J(integrator, cache) # get linear operator
    alg = unwrap_alg(integrator, true)

    if alg.krylov
        w = phiv(
            dt, A, integrator.fsalfirst, 1; m = min(alg.m, size(A, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop
        )
        u = uprev + dt * w[:, 2]
    else
        phihA = cache.ops
        u = uprev + dt * (phihA * integrator.fsalfirst)
    end

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::NorsettEulerCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; rtmp, J, KsCache) = cache
    A = isa(f, SplitFunction) ? f.f1.f : (calc_J!(J, integrator, cache); J) # get linear operator
    alg = unwrap_alg(integrator, true)

    if alg.krylov
        Ks, phiv_cache, ws = KsCache
        w = ws[1]
        arnoldi!(
            Ks, A, integrator.fsalfirst; m = min(alg.m, size(A, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop
        )
        phiv!(w, dt, Ks, 1; cache = phiv_cache)
        @muladd @.. broadcast = false u = uprev + dt * @view(w[:, 2])
    else
        mul!(rtmp, cache.phihA, integrator.fsalfirst)
        @muladd @.. broadcast = false u = uprev + dt * rtmp
    end

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

function perform_step!(integrator, cache::ETDRK2ConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    A = isa(f, SplitFunction) ? f.f1.f : calc_J(integrator, cache) # get linear operator
    alg = unwrap_alg(integrator, true)

    if alg.krylov
        F1 = integrator.fsalfirst
        w1 = phiv(
            dt, A, F1, 2; m = min(alg.m, size(A, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop
        )
        U2 = uprev + dt * w1[:, 2]
        F2 = _compute_nl(f, U2, p, t + dt, A) + A * uprev
        if isa(f, SplitFunction)
            integrator.stats.nf2 += 1
        else
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        end
        w2 = phiv(
            dt, A, F2, 2; m = min(alg.m, size(A, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop
        )
        u = uprev + dt * (w1[:, 2] - w1[:, 3] + w2[:, 3])
    else
        phi1, phi2 = cache.ops
        # The caching version uses a special formula to save computation
        G1 = f.f2(uprev, p, t)
        integrator.stats.nf2 += 1
        F1 = integrator.fsalfirst
        U2 = uprev + dt * (phi1 * F1)
        G2 = f.f2(U2, p, t + dt)
        integrator.stats.nf2 += 1
        u = U2 + dt * (phi2 * (G2 - G1))
    end

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::ETDRK2Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, rtmp, F2, J, KsCache) = cache
    A = isa(f, SplitFunction) ? f.f1.f : (calc_J!(J, integrator, cache); J) # get linear operator
    alg = unwrap_alg(integrator, true)

    if alg.krylov
        F1 = integrator.fsalfirst
        Ks, phiv_cache, ws = KsCache
        w1, w2 = ws
        # Krylov for F1
        arnoldi!(
            Ks, A, F1; m = min(alg.m, size(A, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop
        )
        phiv!(w1, dt, Ks, 2; cache = phiv_cache)
        # Krylov for F2
        @muladd @.. broadcast = false tmp = uprev + dt * @view(w1[:, 2])
        _compute_nl!(F2, f, tmp, p, t + dt, A, rtmp)
        if isa(f, SplitFunction)
            integrator.stats.nf2 += 1
        else
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        end
        F2 .+= mul!(rtmp, A, uprev)
        arnoldi!(
            Ks, A, F2; m = min(alg.m, size(A, 1)),
            opnorm = integrator.opts.internalopnorm, iop = alg.iop
        )
        phiv!(w2, dt, Ks, 2; cache = phiv_cache)
        # Update u
        u .= uprev
        axpy!(dt, @view(w1[:, 2]), u)
        axpy!(-dt, @view(w1[:, 3]), u)
        axpy!(dt, @view(w2[:, 3]), u)
    else
        phi1, phi2 = cache.ops
        F1 = integrator.fsalfirst
        # The caching version uses a special formula to save computation
        # Compute U2
        mul!(rtmp, phi1, F1)
        @muladd @.. broadcast = false tmp = uprev + dt * rtmp # tmp is U2
        # Compute G2 - G1, storing result in the cache F2
        f.f2(rtmp, uprev, p, t)
        integrator.stats.nf2 += 1
        f.f2(F2, tmp, p, t + dt)
        integrator.stats.nf2 += 1
        F2 .-= rtmp # "F2" is G2 - G1
        # Update u
        u .= tmp
        axpy!(dt, mul!(rtmp, phi2, F2), u)
    end

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

function perform_step!(integrator, cache::ETDRK3ConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    A = isa(f, SplitFunction) ? f.f1.f : calc_J(integrator, cache) # get linear operator
    alg = unwrap_alg(integrator, true)

    Au = A * uprev
    F1 = integrator.fsalfirst
    if alg.krylov
        kwargs = (
            m = min(alg.m, size(A, 1)), opnorm = integrator.opts.internalopnorm,
            iop = alg.iop,
        )
        # Krylov on F1 (first column)
        Ks = arnoldi(A, F1; kwargs...)
        w1_half = phiv(dt / 2, Ks, 1)
        w1 = phiv(dt, Ks, 3)
        U2 = uprev + dt / 2 * w1_half[:, 2]
        F2 = _compute_nl(f, U2, p, t + dt / 2, A) + Au
        # Krylov on F2 (second column)
        w2 = phiv(dt, A, F2, 3; kwargs...)
        U3 = uprev + dt * (2w2[:, 2] - w1[:, 2])
        F3 = _compute_nl(f, U3, p, t + dt, A) + Au
        if isa(f, SplitFunction)
            integrator.stats.nf2 += 2
        else
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
        end
        # Krylov on F3 (third column)
        w3 = phiv(dt, A, F3, 3; kwargs...)
        u = uprev +
            dt * (
            4w1[:, 4] - 3w1[:, 3] + w1[:, 2]
                -
                8w2[:, 4] + 4w2[:, 3]
                + 4w3[:, 4] - w3[:, 3]
        )
    else
        A21, A3, B1, B2, B3 = cache.ops
        # stage 1 (fsaled)
        # stage 2
        U2 = uprev + dt * (A21 * F1)
        F2 = f.f2(U2, p, t + dt / 2) + Au
        integrator.stats.nf2 += 1
        # stage 3
        U3 = uprev + dt * (A3 * (2F2 - F1))
        F3 = f.f2(U3, p, t + dt) + Au
        integrator.stats.nf2 += 1
        # update u
        u = uprev + dt * (B1 * F1 + B2 * F2 + B3 * F3)
    end

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::ETDRK3Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, rtmp, Au, F2, F3, J, KsCache) = cache
    A = isa(f, SplitFunction) ? f.f1.f : (calc_J!(J, integrator, cache); J) # get linear operator
    alg = unwrap_alg(integrator, true)

    F1 = integrator.fsalfirst
    mul!(Au, A, uprev)
    halfdt = dt / 2
    if alg.krylov
        Ks, phiv_cache, ws = KsCache
        w1_half, w1, w2, w3 = ws
        kwargs = (
            m = min(alg.m, size(A, 1)), opnorm = integrator.opts.internalopnorm,
            iop = alg.iop,
        )
        # Krylov for F1 (first column)
        arnoldi!(Ks, A, F1; kwargs...)
        phiv!(w1_half, halfdt, Ks, 1; cache = phiv_cache)
        phiv!(w1, dt, Ks, 3; cache = phiv_cache)
        @muladd @.. broadcast = false @views tmp = uprev + halfdt * w1_half[:, 2] # tmp is U2
        _compute_nl!(F2, f, tmp, p, t + halfdt, A, rtmp)
        F2 .+= Au
        # Krylov for F2 (second column)
        arnoldi!(Ks, A, F2; kwargs...)
        phiv!(w2, dt, Ks, 3; cache = phiv_cache)
        @muladd @.. broadcast = false @views tmp = uprev + dt * (2 * w2[:, 2] - w1[:, 2]) # tmp is U3
        _compute_nl!(F3, f, tmp, p, t + dt, A, rtmp)
        F3 .+= Au
        if isa(f, SplitFunction)
            integrator.stats.nf2 += 2
        else
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
        end
        # Krylov for F3 (third column)
        arnoldi!(Ks, A, F3; kwargs...)
        phiv!(w3, dt, Ks, 3; cache = phiv_cache)
        # Update u
        @views @.. broadcast = false rtmp = 4w1[:, 4] - 3w1[:, 3] + w1[:, 2] - 8w2[:, 4] +
            4w2[:, 3] + 4w3[:, 4] - w3[:, 3]
        @muladd @.. broadcast = false u = uprev + dt * rtmp
    else
        A21, A3, B1, B2, B3 = cache.ops
        # stage 1 (fsaled)
        # stage 2
        mul!(rtmp, A21, F1)
        @muladd @.. broadcast = false tmp = uprev + dt * rtmp # tmp is U2
        f.f2(F2, tmp, p, t + halfdt)
        F2 .+= Au
        integrator.stats.nf2 += 1
        # stage 3
        @muladd @.. broadcast = false F3 = 2 * F2 - F1 # use F3 temporarily as cache
        mul!(rtmp, A3, F3)
        @muladd @.. broadcast = false tmp = uprev + dt * rtmp # tmp is U3
        f.f2(F3, tmp, p, t + dt)
        F3 .+= Au
        integrator.stats.nf2 += 1
        # update u
        u .= uprev
        axpy!(dt, mul!(rtmp, B1, F1), u)
        axpy!(dt, mul!(rtmp, B2, F2), u)
        axpy!(dt, mul!(rtmp, B3, F3), u)
    end

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

function perform_step!(integrator, cache::ETDRK4ConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    A = isa(f, SplitFunction) ? f.f1.f : calc_J(integrator, cache) # get linear operator
    alg = unwrap_alg(integrator, true)

    Au = A * uprev
    F1 = integrator.fsalfirst
    halfdt = dt / 2
    if alg.krylov
        kwargs = (
            m = min(alg.m, size(A, 1)), opnorm = integrator.opts.internalopnorm,
            iop = alg.iop,
        )
        # Krylov on F1 (first column)
        Ks = arnoldi(A, F1; kwargs...)
        w1_half = phiv(halfdt, Ks, 1)
        w1 = phiv(dt, Ks, 3)
        U2 = uprev + halfdt * w1_half[:, 2]
        F2 = _compute_nl(f, U2, p, t + halfdt, A) + Au
        # Krylov on F2 (second column)
        Ks = arnoldi(A, F2; kwargs...)
        w2_half = phiv(halfdt, Ks, 1)
        w2 = phiv(dt, Ks, 3)
        U3 = uprev + halfdt * w2_half[:, 2]
        F3 = _compute_nl(f, U3, p, t + halfdt, A) + Au
        # Krylov on F3 (third column)
        w3 = phiv(dt, A, F3, 3; kwargs...)
        # Extra Krylov for computing F4
        rtmp = 2F3 - F1 - Au + A * U2
        wtmp = phiv(halfdt, A, rtmp, 1; kwargs...)
        U4 = U2 + halfdt * wtmp[:, 2]
        F4 = _compute_nl(f, U4, p, t + dt, A) + Au
        if isa(f, SplitFunction)
            integrator.stats.nf2 += 3
        else
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
        end
        # Krylov on F4 (fourth column)
        w4 = phiv(dt, A, F4, 3; kwargs...)
        # update u
        u = uprev +
            dt * (
            w1[:, 2] - 3w1[:, 3] + 4w1[:, 4] + 2w2[:, 3] - 4w2[:, 4] +
                2w3[:, 3] - 4w3[:, 4] + 4w4[:, 4] - w4[:, 3]
        )
    else
        A21, A41, A43, B1, B2, B4 = cache.ops
        # stage 1 (fsaled)
        # stage 2
        U2 = uprev + dt * (A21 * F1)
        F2 = f.f2(U2, p, t + halfdt) + Au
        # stage 3
        U3 = uprev + dt * (A21 * F2) # A32 = A21
        F3 = f.f2(U3, p, t + halfdt) + Au
        # stage 4
        U4 = uprev + dt * (A41 * F1 + A43 * F3)
        F4 = f.f2(U4, p, t + dt) + Au
        integrator.stats.nf2 += 3
        # update u
        u = uprev + dt * (B1 * F1 + B2 * (F2 + F3) + B4 * F4) # B3 = B2
    end

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::ETDRK4Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, rtmp, Au, F2, F3, F4, J, KsCache) = cache
    A = isa(f, SplitFunction) ? f.f1.f : (calc_J!(J, integrator, cache); J) # get linear operator
    alg = unwrap_alg(integrator, true)

    F1 = integrator.fsalfirst
    mul!(Au, A, uprev)
    halfdt = dt / 2
    if alg.krylov
        Ks, phiv_cache, ws = KsCache
        w1_half, w2_half, w1, w2, w3, w4 = ws
        kwargs = (
            m = min(alg.m, size(A, 1)), opnorm = integrator.opts.internalopnorm,
            iop = alg.iop,
        )
        # Krylov for F1 (first column)
        arnoldi!(Ks, A, F1; kwargs...)
        phiv!(w1_half, halfdt, Ks, 1; cache = phiv_cache)
        phiv!(w1, dt, Ks, 3; cache = phiv_cache)
        U2 = u # temporarily use u to store U2 (used in the extra Krylov step)
        @muladd @.. broadcast = false @views U2 = uprev + halfdt * w1_half[:, 2]
        _compute_nl!(F2, f, U2, p, t + halfdt, A, rtmp)
        F2 .+= Au
        # Krylov for F2 (second column)
        arnoldi!(Ks, A, F2; kwargs...)
        phiv!(w2_half, halfdt, Ks, 1; cache = phiv_cache)
        phiv!(w2, dt, Ks, 3; cache = phiv_cache)
        @muladd @.. broadcast = false @views tmp = uprev + halfdt * w2_half[:, 2] # tmp is U3
        _compute_nl!(F3, f, tmp, p, t + halfdt, A, rtmp)
        F3 .+= Au
        # Krylov for F3 (third column)
        arnoldi!(Ks, A, F3; kwargs...)
        phiv!(w3, dt, Ks, 3; cache = phiv_cache)
        # Extra Krylov for computing F4
        # Compute rtmp = 2F3 - F1 - Au + A*U2
        mul!(rtmp, A, U2)
        @.. broadcast = false rtmp += 2F3 - F1 - Au
        arnoldi!(Ks, A, rtmp; kwargs...)
        phiv!(w1_half, halfdt, Ks, 1; cache = phiv_cache) # original w1_half is no longer needed
        @muladd @.. broadcast = false @views tmp = U2 + halfdt * w1_half[:, 2] # tmp is U4
        _compute_nl!(F4, f, tmp, p, t + dt, A, rtmp)
        F4 .+= Au
        if isa(f, SplitFunction)
            integrator.stats.nf2 += 3
        else
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
        end
        # Krylov for F4 (fourth column)
        arnoldi!(Ks, A, F4; kwargs...)
        phiv!(w4, dt, Ks, 3; cache = phiv_cache)
        # update u
        @views @.. broadcast = false rtmp = w1[:, 2] - 3w1[:, 3] + 4w1[:, 4] + 2w2[
            :, 3,
        ] -
            4w2[:, 4] +
            2w3[:, 3] - 4w3[:, 4] + 4w4[:, 4] - w4[:, 3]
        @muladd @.. broadcast = false u = uprev + dt * rtmp
    else
        A21, A41, A43, B1, B2, B4 = cache.ops
        # stage 1 (fsaled)
        # stage 2
        mul!(rtmp, A21, F1)
        @muladd @.. broadcast = false tmp = uprev + dt * rtmp # tmp is U2
        f.f2(F2, tmp, p, t + halfdt)
        F2 .+= Au
        # stage 3
        mul!(rtmp, A21, F2) # A32 = A21
        @muladd @.. broadcast = false tmp = uprev + dt * rtmp # tmp is U3
        f.f2(F3, tmp, p, t + halfdt)
        F3 .+= Au
        # stage 4
        @.. broadcast = false tmp = uprev
        axpy!(dt, mul!(rtmp, A41, F1), tmp)
        axpy!(dt, mul!(rtmp, A43, F3), tmp) # tmp is U4
        f.f2(F4, tmp, p, t + dt)
        F4 .+= Au
        integrator.stats.nf2 += 3
        # update u
        u .= uprev
        axpy!(dt, mul!(rtmp, B1, F1), u)
        F2 .+= F3
        axpy!(dt, mul!(rtmp, B2, F2), u) # B3 = B2
        axpy!(dt, mul!(rtmp, B4, F4), u)
    end

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

function perform_step!(integrator, cache::HochOst4ConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    A = isa(f, SplitFunction) ? f.f1.f : calc_J(integrator, cache) # get linear operator
    alg = unwrap_alg(integrator, true)

    Au = A * uprev
    F1 = integrator.fsalfirst
    halfdt = dt / 2
    if alg.krylov
        kwargs = (
            m = min(alg.m, size(A, 1)), opnorm = integrator.opts.internalopnorm,
            iop = alg.iop,
        )
        # Krylov on F1 (first column)
        Ks = arnoldi(A, F1; kwargs...)
        w1_half = phiv(halfdt, Ks, 3)
        w1 = phiv(dt, Ks, 3)
        U2 = uprev + halfdt * w1_half[:, 2]
        F2 = _compute_nl(f, U2, p, t + halfdt, A) + Au
        # Krylov on F2 (second column)
        Ks = arnoldi(A, F2; kwargs...)
        w2_half = phiv(halfdt, Ks, 3)
        w2 = phiv(dt, Ks, 3)
        U3 = uprev + dt * (0.5w1_half[:, 2] - w1_half[:, 3] + w2_half[:, 3])
        F3 = _compute_nl(f, U3, p, t + halfdt, A) + Au
        # Krylov on F3 (third column)
        Ks = arnoldi(A, F3; kwargs...)
        w3_half = phiv(halfdt, Ks, 3)
        w3 = phiv(dt, Ks, 3)
        U4 = uprev + dt * (w1[:, 2] - 2w1[:, 3] + w2[:, 3] + w3[:, 3])
        F4 = _compute_nl(f, U4, p, t + dt, A) + Au
        # Krylov on F4 (fourth column)
        Ks = arnoldi(A, F4; kwargs...)
        w4_half = phiv(halfdt, Ks, 3)
        w4 = phiv(dt, Ks, 3)
        U5 = uprev +
            dt * (
            0.5w1_half[:, 2] - 0.75w1_half[:, 3] + 0.5w1_half[:, 4] + w1[:, 4] -
                0.25w1[:, 3] +
                0.5w2_half[:, 3] - w2[:, 4] + 0.25w2[:, 3] - 0.5w2_half[:, 4] +
                0.5w3_half[:, 3] - w2[:, 4] + 0.25w3[:, 3] - 0.5w3_half[:, 4] +
                w4[:, 4] - 0.25w4[:, 3] - 0.25w4_half[:, 3] + 0.5w4_half[:, 4]
        )
        F5 = _compute_nl(f, U5, p, t + halfdt, A) + Au
        if isa(f, SplitFunction)
            integrator.stats.nf2 += 4
        else
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
        end
        # Krylov on F5 (fifth column)
        w5 = phiv(dt, A, F5, 3; kwargs...)
        # update u
        u = uprev +
            dt * (
            w1[:, 2] - 3w1[:, 3] + 4w1[:, 4] - w4[:, 3] + 4w4[:, 4] + 4w5[:, 3] -
                8w5[:, 4]
        )
    else
        A21, A31, A32, A41, A42, A51, A52, A54, B1, B4, B5 = cache.ops
        # stage 1 (fsaled)
        # stage 2
        U2 = uprev + dt * (A21 * F1)
        F2 = f.f2(U2, p, t + halfdt) + Au
        # stage 3
        U3 = uprev + dt * (A31 * F1 + A32 * F2)
        F3 = f.f2(U3, p, t + halfdt) + Au
        # stage 4
        U4 = uprev + dt * (A41 * F1 + A42 * (F2 + F3))
        F4 = f.f2(U4, p, t + dt) + Au
        # stage 5
        U5 = uprev + dt * (A51 * F1 + A52 * (F2 + F3) + A54 * F4)
        F5 = f.f2(U5, p, t + halfdt) + Au
        integrator.stats.nf2 += 4
        # update u
        u = uprev + dt * (B1 * F1 + B4 * F4 + B5 * F5)
    end

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::HochOst4Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, rtmp, rtmp2, Au, F2, F3, F4, F5, J, KsCache) = cache
    A = isa(f, SplitFunction) ? f.f1.f : (calc_J!(J, integrator, cache); J) # get linear operator
    alg = unwrap_alg(integrator, true)

    F1 = integrator.fsalfirst
    mul!(Au, A, uprev)
    halfdt = dt / 2
    if alg.krylov
        Ks, phiv_cache, ws = KsCache
        w1_half, w2_half, w3_half, w4_half, w1, w2, w3, w4, w5 = ws
        kwargs = (
            m = min(alg.m, size(A, 1)), opnorm = integrator.opts.internalopnorm,
            iop = alg.iop,
        )
        # Krylov on F1 (first column)
        arnoldi!(Ks, A, F1; kwargs...)
        phiv!(w1_half, halfdt, Ks, 3; cache = phiv_cache)
        phiv!(w1, dt, Ks, 3; cache = phiv_cache)
        @muladd @.. broadcast = false @views tmp = uprev + halfdt * w1_half[:, 2] # tmp is U2
        _compute_nl!(F2, f, tmp, p, t + halfdt, A, rtmp)
        F2 .+= Au
        # Krylov on F2 (second column)
        arnoldi!(Ks, A, F2; kwargs...)
        phiv!(w2_half, halfdt, Ks, 3; cache = phiv_cache)
        phiv!(w2, dt, Ks, 3; cache = phiv_cache)
        @muladd @.. broadcast = false @views tmp = uprev +
            dt * (
            0.5w1_half[:, 2] - w1_half[:, 3] +
                w2_half[:, 3]
        ) # tmp is U3
        _compute_nl!(F3, f, tmp, p, t + halfdt, A, rtmp)
        F3 .+= Au
        # Krylov on F3 (third column)
        arnoldi!(Ks, A, F3; kwargs...)
        phiv!(w3_half, halfdt, Ks, 3; cache = phiv_cache)
        phiv!(w3, dt, Ks, 3; cache = phiv_cache)
        @muladd @.. broadcast = false @views tmp = uprev +
            dt * (
            w1[:, 2] - 2w1[:, 3] + w2[:, 3] +
                w3[:, 3]
        ) # tmp is U4
        _compute_nl!(F4, f, tmp, p, t + dt, A, rtmp)
        F4 .+= Au
        # Krylov on F4 (fourth column)
        arnoldi!(Ks, A, F4; kwargs...)
        phiv!(w4_half, halfdt, Ks, 3; cache = phiv_cache)
        phiv!(w4, dt, Ks, 3; cache = phiv_cache)
        @muladd @.. broadcast = false @views tmp = uprev +
            dt *
            (
            0.5w1_half[:, 2] - 0.75w1_half[:, 3] +
                0.5w1_half[:, 4] + w1[:, 4] -
                0.25w1[:, 3] +
                0.5w2_half[:, 3] - w2[:, 4] +
                0.25w2[:, 3] - 0.5w2_half[:, 4] +
                0.5w3_half[:, 3] - w2[:, 4] +
                0.25w3[:, 3] - 0.5w3_half[:, 4] +
                w4[:, 4] - 0.25w4[:, 3] -
                0.25w4_half[:, 3] + 0.5w4_half[:, 4]
        ) # tmp is U5
        _compute_nl!(F5, f, tmp, p, t + dt, A, rtmp)
        F5 .+= Au
        if isa(f, SplitFunction)
            integrator.stats.nf2 += 4
        else
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
        end
        # Krylov on F5 (fifth column)
        arnoldi!(Ks, A, F5; kwargs...)
        phiv!(w5, dt, Ks, 3; cache = phiv_cache)
        # update u
        @muladd @.. broadcast = false @views rtmp = w1[:, 2] - 3w1[:, 3] + 4w1[:, 4] -
            w4[:, 3] + 4w4[:, 4] + 4w5[:, 3] -
            8w5[:, 4]
        @muladd @.. broadcast = false u = uprev + dt * rtmp
    else
        A21, A31, A32, A41, A42, A51, A52, A54, B1, B4, B5 = cache.ops
        # stage 1 (fsaled)
        # stage 2
        mul!(rtmp, A21, F1)
        @muladd @.. broadcast = false tmp = uprev + dt * rtmp # tmp is U2
        f.f2(F2, tmp, p, t + halfdt)
        F2 .+= Au
        # stage 3
        mul!(rtmp, A31, F1)
        mul!(rtmp2, A32, F2)
        rtmp .+= rtmp2
        @muladd @.. broadcast = false tmp = uprev + dt * rtmp # tmp is U3
        f.f2(F3, tmp, p, t + halfdt)
        F3 .+= Au
        # stage 4
        F2 .+= F3 # F2 now stores F2 + F3
        mul!(rtmp, A41, F1)
        mul!(rtmp2, A42, F2)
        rtmp .+= rtmp2
        @muladd @.. broadcast = false tmp = uprev + dt * rtmp # tmp is U4
        f.f2(F4, tmp, p, t + dt)
        F4 .+= Au
        # stage 5
        mul!(rtmp, A51, F1)
        mul!(rtmp2, A52, F2)
        rtmp .+= rtmp2
        mul!(rtmp2, A54, F4)
        rtmp .+= rtmp2
        @muladd @.. broadcast = false tmp = uprev + dt * rtmp # tmp is U5
        f.f2(F5, tmp, p, t + halfdt)
        F5 .+= Au
        integrator.stats.nf2 += 4
        # update u
        mul!(rtmp, B1, F1)
        mul!(rtmp2, B4, F4)
        rtmp .+= rtmp2
        mul!(rtmp2, B5, F5)
        rtmp .+= rtmp2
        @muladd @.. broadcast = false u = uprev + dt * rtmp
    end

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

#############################################
# EPIRK integrators
function perform_step!(integrator, cache::Exp4ConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    J = calc_J(integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(uprev) is fsaled
    ts = [dt / 3, 2dt / 3, dt]
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)),
    )

    # Krylov for f(uprev)
    B1 = [zero(f0) f0]
    K1 = phiv_timestep(ts, J, B1; kwargs...) # tϕ(tA)f0
    @inbounds for i in 1:3
        K1[:, i] ./= ts[i]
    end
    w4 = K1 * [-7 / 300, 97 / 150, -37 / 300]
    u4 = uprev + dt * w4
    d4 = f(u4, p, t + dt) - f0 - dt * (J * w4) # TODO: what should be the time?
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # Krylov for the first remainder d4
    B2 = [zero(d4) d4]
    K2 = phiv_timestep(ts, J, B2; kwargs...)
    @inbounds for i in 1:3
        K2[:, i] ./= ts[i]
    end
    w7 = K1 * [59 / 300, -7 / 75, 269 / 300] + K2 * [2 / 3, 2 / 3, 2 / 3]
    u7 = uprev + dt * w7
    d7 = f(u7, p, t + dt) - f0 - dt * (J * w7)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # Krylov for the second remainder d7
    B3 = [zero(d7) d7]
    k7 = phiv_timestep(ts[1], J, B3; kwargs...)
    k7 ./= ts[1]
    # Update u
    u = uprev + dt * (K1[:, 3] + K2[:, 1] - 4 / 3 * K2[:, 2] + K2[:, 3] + k7 / 6)

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::Exp4Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, rtmp, rtmp2, K, J, B, KsCache) = cache
    calc_J!(J, integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(u0) is fsaled
    ts = [dt / 3, 2dt / 3, dt]
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)), caches = KsCache,
    )

    # Krylov for f(uprev)
    B[:, 2] .= f0
    phiv_timestep!(K, ts, J, B; kwargs...)
    @inbounds for i in 1:3
        K[:, i] ./= ts[i]
    end
    mul!(rtmp, K, [-7 / 300, 97 / 150, -37 / 300]) # rtmp is now w4
    @muladd @.. broadcast = false tmp = uprev + dt * rtmp # tmp is now u4
    mul!(rtmp2, J, rtmp)
    f(rtmp, tmp, p, t + dt) # TODO: what should be the time?
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    @muladd @.. broadcast = false @view(B[:, 2]) = rtmp - f0 - dt * rtmp2 # B[:,2] is now d4
    # Partially update entities that use k1, k2, k3
    mul!(rtmp, K, [59 / 300, -7 / 75, 269 / 300]) # rtmp is now w7
    @muladd @.. broadcast = false u = uprev + dt * @view(K[:, 3])
    # Krylov for the first remainder d4
    phiv_timestep!(K, ts, J, B; kwargs...)
    @inbounds for i in 1:3
        K[:, i] ./= ts[i]
    end
    mul!(rtmp2, K, [2 / 3, 2 / 3, 2 / 3])
    rtmp .+= rtmp2 # w7 fully updated
    @muladd @.. broadcast = false tmp = uprev + dt * rtmp # tmp is now u7
    mul!(rtmp2, J, rtmp)
    f(rtmp, tmp, p, t + dt) # TODO: what should be the time?
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    @muladd @.. broadcast = false @view(B[:, 2]) = rtmp - f0 - dt * rtmp2 # B[:,2] is now d7
    # Partially update entities that use k4, k5, k6
    mul!(rtmp, K, [1.0, -4 / 3, 1.0])
    axpy!(dt, rtmp, u)
    # Krylov for the second remainder d7
    k7 = @view(K[:, 1])
    phiv_timestep!(k7, ts[1], J, B; kwargs...)
    k7 ./= ts[1]
    axpy!(dt / 6, k7, u)

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

function perform_step!(integrator, cache::EPIRK4s3AConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    J = calc_J(integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(uprev) is fsaled
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)),
    )

    # Compute U2 and U3 vertically
    K = phiv_timestep([dt / 2, 2dt / 3], J, [zero(f0) f0]; kwargs...)
    U2 = uprev + K[:, 1]
    U3 = uprev + K[:, 2]
    R2 = f(U2, p, t + dt / 2) - f0 - J * K[:, 1] # remainder of U2
    R3 = f(U3, p, t + 2dt / 3) - f0 - J * K[:, 2] # remainder of U3
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)

    # Update u (horizontally)
    B = zeros(eltype(f0), length(f0), 5)
    B[:, 2] = f0
    B[:, 4] = (32R2 - 13.5R3) / dt^2
    B[:, 5] = (-144R2 + 81R3) / dt^3
    u = uprev + phiv_timestep(dt, J, B; kwargs...)

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::EPIRK4s3ACache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, rtmp, rtmp2, K, J, B, KsCache) = cache
    calc_J!(J, integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(u0) is fsaled
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)), caches = KsCache,
    )

    # Compute U2 and U3 vertically
    B[:, 2] .= f0
    phiv_timestep!(K, [dt / 2, 2dt / 3], J, @view(B[:, 1:2]); kwargs...)
    ## U2 and R2
    @.. broadcast = false tmp = uprev + @view(K[:, 1]) # tmp is now U2
    f(rtmp, tmp, p, t + dt / 2)
    mul!(rtmp2, J, @view(K[:, 1]))
    @.. broadcast = false rtmp = rtmp - f0 - rtmp2 # rtmp is now R2
    B[:, 4] .= (32 / dt^2) * rtmp
    B[:, 5] .= (-144 / dt^3) * rtmp
    ## U3 and R3
    @.. broadcast = false tmp = uprev + @view(K[:, 2]) # tmp is now U3
    f(rtmp, tmp, p, t + 2dt / 3)
    mul!(rtmp2, J, @view(K[:, 2]))
    @.. broadcast = false rtmp = rtmp - f0 - rtmp2 # rtmp is now R3
    B[:, 4] .-= (13.5 / dt^2) * rtmp
    B[:, 5] .+= (81 / dt^3) * rtmp
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)

    # Update u
    du = @view(K[:, 1])
    phiv_timestep!(du, dt, J, B; kwargs...)
    @.. broadcast = false u = uprev + du

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

function perform_step!(integrator, cache::EPIRK4s3BConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    J = calc_J(integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(uprev) is fsaled
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)),
    )

    # Compute U2 and U3 vertically
    K = phiv_timestep([dt / 2, 3dt / 4], J, [zero(f0) zero(f0) f0]; kwargs...)
    K[:, 1] .*= 8 / (3 * dt)
    K[:, 2] .*= 16 / (9 * dt)
    U2 = uprev + K[:, 1]
    U3 = uprev + K[:, 2]
    R2 = f(U2, p, t + dt / 2) - f0 - J * K[:, 1] # remainder of U2
    R3 = f(U3, p, t + 3dt / 4) - f0 - J * K[:, 2] # remainder of U3
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)

    # Update u (horizontally)
    B = zeros(eltype(f0), length(f0), 5)
    B[:, 2] = f0
    B[:, 4] = (54R2 - 16R3) / dt^2
    B[:, 5] = (-324R2 + 144R3) / dt^3
    u = uprev + phiv_timestep(dt, J, B; kwargs...)

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::EPIRK4s3BCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, rtmp, rtmp2, K, J, B, KsCache) = cache
    calc_J!(J, integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(u0) is fsaled
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)), caches = KsCache,
    )

    # Compute U2 and U3 vertically
    fill!(@view(B[:, 2]), zero(eltype(B)))
    B[:, 3] .= f0
    phiv_timestep!(K, [dt / 2, 3dt / 4], J, @view(B[:, 1:3]); kwargs...)
    K[:, 1] .*= 8 / (3 * dt)
    K[:, 2] .*= 16 / (9 * dt)
    ## U2 and R2
    @.. broadcast = false tmp = uprev + @view(K[:, 1]) # tmp is now U2
    f(rtmp, tmp, p, t + dt / 2)
    mul!(rtmp2, J, @view(K[:, 1]))
    @.. broadcast = false rtmp = rtmp - f0 - rtmp2 # rtmp is now R2
    B[:, 4] .= (54 / dt^2) * rtmp
    B[:, 5] .= (-324 / dt^3) * rtmp
    ## U3 and R3
    @.. broadcast = false tmp = uprev + @view(K[:, 2]) # tmp is now U3
    f(rtmp, tmp, p, t + 3dt / 4)
    mul!(rtmp2, J, @view(K[:, 2]))
    @.. broadcast = false rtmp = rtmp - f0 - rtmp2 # rtmp is now R3
    B[:, 4] .-= (16 / dt^2) * rtmp
    B[:, 5] .+= (144 / dt^3) * rtmp
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)

    # Update u
    fill!(@view(B[:, 3]), zero(eltype(B)))
    B[:, 2] .= f0
    du = @view(K[:, 1])
    phiv_timestep!(du, dt, J, B; kwargs...)
    @.. broadcast = false u = uprev + du

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

function perform_step!(integrator, cache::EPIRK5s3ConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    J = calc_J(integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(uprev) is fsaled
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)),
    )

    # Compute U2 horizontally
    B = fill(zero(eltype(f0)), length(f0), 4)
    B[:, 3] = (55 / (8 * dt)) * f0
    B[:, 4] = (-3025 / (192 * dt^2)) * f0
    k = phiv_timestep(48dt / 55, J, B; kwargs...)
    U2 = uprev + k
    R2 = f(U2, p, t + 48dt / 55) - f0 - J * k # remainder of U2
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Compute U3 horizontally
    B[:, 2] = (53 / 5) * f0
    B[:, 3] = (-648 / (5 * dt)) * f0
    B[:, 4] = (2916 / (5 * dt^2)) * f0 + (32065 / (1152 * dt^2)) * R2
    k = phiv_timestep(4dt / 9, J, B; kwargs...)
    U3 = uprev + k
    R3 = f(U3, p, t + 4dt / 9) - f0 - J * k # remainder of U3
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Update u (horizontally)
    B = fill(zero(eltype(f0)), length(f0), 5)
    B[:, 2] = f0
    B[:, 4] = (-166375 / (61056 * dt^2)) * R2 + (2187 / (106 * dt^2)) * R3
    B[:, 5] = (499125 / (27136 * dt^3)) * R2 - (2187 / (106 * dt^3)) * R3
    u = uprev + phiv_timestep(dt, J, B; kwargs...)

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::EPIRK5s3Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, k, rtmp, rtmp2, J, B, KsCache) = cache
    calc_J!(J, integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(u0) is fsaled
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)), caches = KsCache,
    )

    # Compute U2 horizontally
    fill!(@view(B[:, 2]), zero(eltype(B)))
    B[:, 3] .= (55 / (8 * dt)) .* f0
    B[:, 4] .= (-3025 / (192 * dt^2)) .* f0
    phiv_timestep!(k, 48dt / 55, J, @view(B[:, 1:4]); kwargs...)
    ## Compute R2
    @.. broadcast = false tmp = uprev + k # tmp is now U2
    f(rtmp, tmp, p, t + 48dt / 55)
    mul!(rtmp2, J, k)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    @.. broadcast = false rtmp = rtmp - f0 - rtmp2 # rtmp is now R2

    # Compute U3 horizontally
    B[:, 2] .= (53 / 5) .* f0
    B[:, 3] .= (-648 / (5 * dt)) .* f0
    B[:, 4] .= (2916 / (5 * dt^2)) .* f0 + (32065 / (1152 * dt^2)) .* rtmp
    phiv_timestep!(k, 4dt / 9, J, @view(B[:, 1:4]); kwargs...)
    ## Update B matrix using R2
    B[:, 2] .= f0
    fill!(@view(B[:, 3]), zero(eltype(B)))
    B[:, 4] .= (-166375 / (61056 * dt^2)) .* rtmp
    B[:, 5] .= (499125 / (27136 * dt^3)) .* rtmp
    ## Compute R3 and update B
    @.. broadcast = false tmp = uprev + k # tmp is now U3
    f(rtmp, tmp, p, t + 4dt / 9)
    mul!(rtmp2, J, k)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    @.. broadcast = false rtmp = rtmp - f0 - rtmp2 # rtmp is now R3
    B[:, 4] .+= (2187 / (106 * dt^2)) .* rtmp
    B[:, 5] .-= (2187 / (106 * dt^3)) .* rtmp

    # Update u
    phiv_timestep!(k, dt, J, B; kwargs...)
    @.. broadcast = false u = uprev + k

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

function perform_step!(integrator, cache::EXPRB53s3ConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    J = calc_J(integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(uprev) is fsaled
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)),
    )

    # Compute the first group for U2 and U3
    B = [zero(f0) f0]
    K = phiv_timestep([dt / 2, 9dt / 10], J, B; kwargs...)
    U2 = uprev + K[:, 1]
    R2 = f(U2, p, t + dt / 2) - f0 - J * K[:, 1] # remainder of U2
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    U3 = uprev + K[:, 2] # partially

    # Compute the second group for U3
    B = [zero(R2) zero(R2) zero(R2) R2]
    K = phiv_timestep([dt / 2, 9dt / 10], J, B; kwargs...)
    U3 .+= 216 / (25 * dt^2) .* K[:, 1] + 8 / dt^2 .* K[:, 2]
    R3 = f(U3, p, t + 9dt / 10) - f0 - J * (U3 - uprev) # remainder of U3
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Compute the third group for u
    B = fill(zero(eltype(f0)), length(f0), 5)
    B[:, 2] = f0
    B[:, 4] = (18 / dt^2) * R2 - (250 / (81 * dt^2)) * R3
    B[:, 5] = (-60 / dt^3) * R2 + (500 / (27 * dt^3)) * R3
    u = uprev + phiv_timestep(dt, J, B; kwargs...)

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::EXPRB53s3Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, rtmp, rtmp2, K, J, B, KsCache) = cache
    calc_J!(J, integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(u0) is fsaled
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)), caches = KsCache,
    )

    # Compute the first group for U2 and U3
    B[:, 2] .= f0
    phiv_timestep!(K, [dt / 2, 9dt / 10], J, @view(B[:, 1:2]); kwargs...)
    ## U2 and R2
    @.. broadcast = false tmp = uprev + @view(K[:, 1]) # tmp is now U2
    f(rtmp, tmp, p, t + dt / 2)
    mul!(rtmp2, J, @view(K[:, 1]))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    @.. broadcast = false rtmp = rtmp - f0 - rtmp2 # rtmp is now R2
    @.. broadcast = false tmp = uprev + @view(K[:, 2]) # tmp is now U3 (partially)

    # Compute the second group for U3
    fill!(@view(B[:, 2]), zero(eltype(B)))
    B[:, 4] .= rtmp
    phiv_timestep!(K, [dt / 2, 9dt / 10], J, @view(B[:, 1:4]); kwargs...)
    ## Update B using R2
    B[:, 2] .= f0
    B[:, 4] .= (18 / dt^2) .* rtmp
    B[:, 5] .= (-60 / dt^3) .* rtmp
    ## U3 and R3
    @views tmp .+= 216 / (25 * dt^2) .* K[:, 1] + 8 / dt^2 .* K[:, 2] # tmp is now U3
    f(rtmp, tmp, p, t + 9dt / 10)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    tmp .-= uprev
    mul!(rtmp2, J, tmp)
    @.. broadcast = false rtmp = rtmp - f0 - rtmp2 # rtmp is now R3
    ## Update B using R3
    B[:, 4] .-= (250 / (81 * dt^2)) * rtmp
    B[:, 5] .+= (500 / (27 * dt^3)) * rtmp

    # Update u
    du = @view(K[:, 1])
    phiv_timestep!(du, dt, J, B; kwargs...)
    @.. broadcast = false u = uprev + du

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

function perform_step!(integrator, cache::EPIRK5P1ConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    J = calc_J(integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(uprev) is fsaled
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)),
    )

    # Coefficients (scaling factors absorbed)
    g11 = 0.35129592695058193092 * dt
    g21 = 0.84405472011657126298 * dt # g22 = g32
    g31 = dt
    g32 = 0.71111095364366870359 * dt
    g33 = 0.62378111953371494809 * dt
    a22 = 2.37739153404186675585
    b2 = 1.78975267532362337976
    b3 = 9.35854650579261718128 / dt^2

    # Compute the first column (f0)
    B = [zero(f0) f0]
    K1 = phiv_timestep([g11, g21, g31], J, B; kwargs...)
    ## U1 and R1
    U1 = uprev + K1[:, 1]
    R1 = f(U1, p, t + g11) - f0 - J * K1[:, 1] # remainder of U1
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Compute the second column (R1)
    B = [zero(R1) R1]
    k2 = phiv_timestep(g32, J, B; kwargs...)
    ## U2 and R2
    U2 = uprev + K1[:, 2] + a22 * k2
    R2 = f(U2, p, t + g21) - f0 - J * (U2 - uprev) # remainder of U2
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Compute the third column (dR = R2 - 2R1)
    B = fill(zero(eltype(f0)), length(f0), 4)
    B[:, 4] = R2 - 2R1
    k3 = phiv_timestep(g33, J, B; kwargs...)
    ## Update state
    u = uprev + K1[:, 3] + b2 * k2 + b3 * k3

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::EPIRK5P1Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, rtmp, rtmp2, K, J, B, KsCache) = cache
    calc_J!(J, integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(u0) is fsaled
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)), caches = KsCache,
    )

    # Coefficients (scaling factors absorbed)
    g11 = 0.35129592695058193092 * dt
    g21 = 0.84405472011657126298 * dt # g22 = g32
    g31 = dt
    g32 = 0.71111095364366870359 * dt
    g33 = 0.62378111953371494809 * dt
    a22 = 2.37739153404186675585
    b2 = 1.78975267532362337976
    b3 = 9.35854650579261718128 / dt^2

    # Compute the first column (f0)
    B[:, 2] .= f0
    phiv_timestep!(K, [g11, g21, g31], J, @view(B[:, 1:2]); kwargs...)
    ## U1 and R1
    @.. broadcast = false tmp = uprev + @view(K[:, 1]) # tmp is now U1
    f(rtmp, tmp, p, t + g11)
    mul!(rtmp2, J, @view(K[:, 1]))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    @.. broadcast = false rtmp = rtmp - f0 - rtmp2 # rtmp is now R1
    @.. broadcast = false tmp = uprev + @view(K[:, 2]) # partially update U2 (stored tmp)
    @.. broadcast = false u = uprev + @view(K[:, 3]) # partially update u
    B[:, 2] .= rtmp
    @.. broadcast = false @view(B[:, 4]) = (-2) * rtmp

    # Compute the second column (R1)
    k = @view(K[:, 1])
    phiv_timestep!(k, g32, J, @view(B[:, 1:2]); kwargs...)
    ## U2 and R2
    axpy!(a22, k, tmp) # tmp is now U2
    f(rtmp, tmp, p, t + g21)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    tmp .-= uprev
    mul!(rtmp2, J, tmp)
    @.. broadcast = false rtmp = rtmp - f0 - rtmp2 # rtmp is now R2
    axpy!(b2, k, u) # partially update u
    B[:, 4] .+= rtmp # is now dR

    # Compute the third column (dR = R2 - 2R1)
    fill!(@view(B[:, 2]), zero(eltype(B)))
    phiv_timestep!(k, g33, J, B; kwargs...)
    axpy!(b3, k, u)

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

function perform_step!(integrator, cache::EPIRK5P2ConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    J = calc_J(integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(uprev) is fsaled
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)),
    )

    # Coefficients (scaling factors absorbed)
    g11 = 0.46629408528088195806 * dt
    g21 = 0.8821791265336386514 * dt # g22 = g32
    g31 = dt
    g32 = 0.92074916488140031449 * dt
    g33 = 0.79791561832664517267 * dt
    a22 = 2.80620373289331259751 / dt
    b2 = 2.52806310256246280783 / dt
    b31 = -0.128486782657005566142
    b32 = -0.161028033172809183351 / dt
    b33 = 5.26726331616909606251 / dt^2

    # Compute the first column (f0)
    B = [zero(f0) f0]
    K1 = phiv_timestep([g11, g21, g31], J, B; kwargs...)
    ## U1 and R1
    U1 = uprev + K1[:, 1]
    R1 = f(U1, p, t + g11) - f0 - J * K1[:, 1] # remainder of U1
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Compute the second column (R1)
    B = [zero(R1) zero(R1) R1]
    k2 = phiv_timestep(g32, J, B; kwargs...)
    ## U2 and R2
    U2 = uprev + K1[:, 2] + a22 * k2
    R2 = f(U2, p, t + g21) - f0 - J * (U2 - uprev) # remainder of U2
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Compute the third column (dR = R2 - 2R1)
    dR = R2 - 2R1
    B = [zero(dR) b31 * dR b32 * dR b33 * dR]
    k3 = phiv_timestep(g33, J, B; kwargs...)
    ## Update state
    u = uprev + K1[:, 3] + b2 * k2 + k3

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::EPIRK5P2Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, rtmp, rtmp2, dR, K, J, B, KsCache) = cache
    calc_J!(J, integrator, cache)
    alg = unwrap_alg(integrator, true)
    f0 = integrator.fsalfirst # f(u0) is fsaled
    kwargs = (
        tol = integrator.opts.reltol, iop = alg.iop,
        opnorm = integrator.opts.internalopnorm,
        adaptive = alg.adaptive_krylov, tau = (alg.adaptive_krylov ? 0.0 : dt),
        m = min(alg.m, size(J, 1)), caches = KsCache,
    )

    # Coefficients (scaling factors absorbed)
    g11 = 0.46629408528088195806 * dt
    g21 = 0.8821791265336386514 * dt # g22 = g32
    g31 = dt
    g32 = 0.92074916488140031449 * dt
    g33 = 0.79791561832664517267 * dt
    a22 = 2.80620373289331259751 / dt
    b2 = 2.52806310256246280783 / dt
    b31 = -0.128486782657005566142
    b32 = -0.161028033172809183351 / dt
    b33 = 5.26726331616909606251 / dt^2

    # Compute the first column (f0)
    B[:, 2] .= f0
    phiv_timestep!(K, [g11, g21, g31], J, @view(B[:, 1:2]); kwargs...)
    ## U1 and R1
    @.. broadcast = false tmp = uprev + @view(K[:, 1]) # tmp is now U1
    f(rtmp, tmp, p, t + g11)
    mul!(rtmp2, J, @view(K[:, 1]))
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    @.. broadcast = false rtmp = rtmp - f0 - rtmp2 # rtmp is now R1
    @.. broadcast = false tmp = uprev + @view(K[:, 2]) # partially update U2 (stored in tmp)
    @.. broadcast = false u = uprev + @view(K[:, 3]) # partially update u
    @.. broadcast = false dR = -2rtmp # partially update dR

    # Compute the second column (R1)
    fill!(@view(B[:, 2]), zero(eltype(B)))
    B[:, 3] .= rtmp
    k = @view(K[:, 1])
    phiv_timestep!(k, g32, J, @view(B[:, 1:3]); kwargs...)
    ## U2 and R2
    axpy!(a22, k, tmp) # tmp is now U2
    f(rtmp, tmp, p, t + g21)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    tmp .-= uprev
    mul!(rtmp2, J, tmp)
    @.. broadcast = false rtmp = rtmp - f0 - rtmp2 # rtmp is now R2
    dR .+= rtmp # dR is now R2 - 2R1
    axpy!(b2, k, u) # partially update u

    # Compute the third column (dR = R2 - 2R1)
    @.. broadcast = false @view(B[:, 2]) = b31 * dR
    @.. broadcast = false @view(B[:, 3]) = b32 * dR
    @.. broadcast = false @view(B[:, 4]) = b33 * dR
    phiv_timestep!(k, g33, J, B; kwargs...)
    u .+= k

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

######################################################
# Adaptive exponential Rosenbrock integrators
function perform_step!(integrator, cache::Exprb32ConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    A = calc_J(integrator, cache) # get linear operator
    alg = unwrap_alg(integrator, true)

    F1 = integrator.fsalfirst
    w1 = phiv(
        dt, A, F1, 3; m = min(alg.m, size(A, 1)),
        opnorm = integrator.opts.internalopnorm, iop = alg.iop
    )
    U2 = uprev + dt * w1[:, 2]
    F2 = _compute_nl(f, U2, p, t + dt, A) + A * uprev
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    w2 = phiv(
        dt, A, F2, 3; m = min(alg.m, size(A, 1)),
        opnorm = integrator.opts.internalopnorm, iop = alg.iop
    )
    u = uprev + dt * (w1[:, 2] - 2w1[:, 4] + 2w2[:, 4])
    if integrator.opts.adaptive
        # error estimator for the imbedded method
        utilde = 2dt * (-w1[:, 4] + w2[:, 4])
        atmp = calculate_residuals(
            utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::Exprb32Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; utilde, tmp, rtmp, F2, J, KsCache) = cache
    calc_J!(J, integrator, cache)
    alg = unwrap_alg(integrator, true)

    F1 = integrator.fsalfirst
    Ks, phiv_cache, ws = KsCache
    w1, w2 = ws
    # Krylov for F1
    arnoldi!(
        Ks, J, F1; m = min(alg.m, size(J, 1)), opnorm = integrator.opts.internalopnorm,
        iop = alg.iop
    )
    phiv!(w1, dt, Ks, 3; cache = phiv_cache)
    # Krylov for F2
    @muladd @.. broadcast = false tmp = uprev + dt * @view(w1[:, 2])
    _compute_nl!(F2, f, tmp, p, t + dt, J, rtmp)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    F2 .+= mul!(rtmp, J, uprev)
    arnoldi!(
        Ks, J, F2; m = min(alg.m, size(J, 1)), opnorm = integrator.opts.internalopnorm,
        iop = alg.iop
    )
    phiv!(w2, dt, Ks, 3; cache = phiv_cache)
    # Update u
    u .= uprev
    axpy!(dt, @view(w1[:, 2]), u)
    axpy!(-2dt, @view(w1[:, 4]), u)
    axpy!(2dt, @view(w2[:, 4]), u)
    if integrator.opts.adaptive
        # error estimator for the imbedded method
        @views @.. broadcast = false utilde = (2 * dt) * (-w1[:, 4] + w2[:, 4])
        calculate_residuals!(
            tmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

function perform_step!(integrator, cache::Exprb43ConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    A = calc_J(integrator, cache) # get linear operator
    alg = unwrap_alg(integrator, true)

    Au = A * uprev
    F1 = integrator.fsalfirst
    kwargs = (
        m = min(alg.m, size(A, 1)), opnorm = integrator.opts.internalopnorm,
        iop = alg.iop,
    )
    # Krylov on F1 (first column)
    Ks = arnoldi(A, F1; kwargs...)
    w1_half = phiv(dt / 2, Ks, 1)
    w1 = phiv(dt, Ks, 4)
    U2 = uprev + dt / 2 * w1_half[:, 2]
    F2 = _compute_nl(f, U2, p, t + dt / 2, A) + Au
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # Krylov on F2 (second column)
    w2 = phiv(dt, A, F2, 4; kwargs...)
    U3 = uprev + dt * w2[:, 2]
    F3 = _compute_nl(f, U3, p, t + dt, A) + Au
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # Krylov on F3 (third column)
    w3 = phiv(dt, A, F3, 4; kwargs...)
    u = uprev +
        dt * (
        w1[:, 2] - 14w1[:, 4] + 36w1[:, 5] + 16w2[:, 4] - 48w2[:, 5] - 2w3[:, 4] +
            12w3[:, 5]
    )
    if integrator.opts.adaptive
        # error estimator for the imbedded method
        utilde = dt * (36w1[:, 5] - 48w2[:, 5] + 12w3[:, 5])
        atmp = calculate_residuals(
            utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    # Update integrator state
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    return integrator.u = u
end

function perform_step!(integrator, cache::Exprb43Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; utilde, tmp, rtmp, Au, F2, F3, J, KsCache) = cache
    calc_J!(J, integrator, cache)
    alg = unwrap_alg(integrator, true)

    F1 = integrator.fsalfirst
    mul!(Au, J, uprev)
    halfdt = dt / 2
    Ks, phiv_cache, ws = KsCache
    w1_half, w1, w2, w3 = ws
    kwargs = (
        m = min(alg.m, size(J, 1)), opnorm = integrator.opts.internalopnorm,
        iop = alg.iop,
    )
    # Krylov for F1
    arnoldi!(Ks, J, F1; kwargs...)
    phiv!(w1_half, halfdt, Ks, 1; cache = phiv_cache)
    phiv!(w1, dt, Ks, 4; cache = phiv_cache)
    @muladd @.. broadcast = false @views tmp = uprev + halfdt * w1_half[:, 2] # tmp is U2
    _compute_nl!(F2, f, tmp, p, t + halfdt, J, rtmp)
    F2 .+= Au
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # Krylov for F2
    arnoldi!(Ks, J, F2; kwargs...)
    phiv!(w2, dt, Ks, 4; cache = phiv_cache)
    @muladd @.. broadcast = false @views tmp = uprev + dt * w2[:, 2] # tmp is U3
    _compute_nl!(F3, f, tmp, p, t + dt, J, rtmp)
    F3 .+= Au
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # Krylov for F3 (third column)
    arnoldi!(Ks, J, F3; kwargs...)
    phiv!(w3, dt, Ks, 4; cache = phiv_cache)
    # Update u
    @views @.. broadcast = false rtmp = w1[:, 2] - 14w1[:, 4] + 36w1[:, 5] + 16w2[:, 4] -
        48w2[:, 5] - 2w3[:, 4] + 12w3[:, 5]
    @muladd @.. broadcast = false u = uprev + dt * rtmp
    if integrator.opts.adaptive
        @views @.. broadcast = false rtmp = 36w1[:, 5] - 48w2[:, 5] + 12w3[:, 5]
        @.. broadcast = false utilde = dt * rtmp
        calculate_residuals!(
            tmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end

    # Update integrator state
    f(integrator.fsallast, u, p, t + dt)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # integrator.k is automatically set due to aliasing
end

######################################################
# Multistep exponential integrators
function initialize!(integrator, cache::ETD2ConstantCache)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Pre-start fsal
    lin = integrator.f.f1(integrator.uprev, integrator.p, integrator.t)
    nl = integrator.f.f2(integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.stats.nf2 += 1
    nlprev = zero(nl) # to be computed in the first iteration via ETD1
    integrator.fsalfirst = ETD2Fsal(lin, nl, nlprev)

    # Avoid undefined entries if k is an array of arrays
    rate_prototype = lin
    integrator.fsallast = ETD2Fsal(rate_prototype)
    integrator.k[1] = lin + nl
    return integrator.k[2] = zero(rate_prototype)
end

function perform_step!(integrator, cache::ETD2ConstantCache, repeat_step = false)
    (; t, dt, uprev, f, p) = integrator
    (; lin, nl, nlprev) = integrator.fsalfirst
    (; exphA, phihA, B1, B0) = cache
    integrator.k[1] = lin + nl

    if integrator.iter == 1 # ETD1 for initial step
        u = exphA * uprev + dt * (phihA * nl)
    else
        u = exphA * uprev + dt * (B1 * nl + B0 * nlprev)
    end
    integrator.u = u

    # Push the fsal at t+dt
    nlprev = nl
    lin = f.f1(u, p, t + dt)
    nl = f.f2(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.stats.nf2 += 1
    integrator.k[2] = lin + nl
    integrator.fsallast.lin = lin
    integrator.fsallast.nl = nl
    return integrator.fsallast.nlprev = nlprev
end

function initialize!(integrator, cache::ETD2Cache)
    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    rate_prototype = cache.rtmp1

    # Pre-start fsal
    (; lin, nl) = integrator.fsalfirst
    integrator.f.f1(lin, integrator.uprev, integrator.p, integrator.t)
    integrator.f.f2(nl, integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.stats.nf2 += 1

    # Avoid undefined entries if k is an array of arrays
    integrator.k[1] = lin + nl
    return integrator.k[2] = zero(rate_prototype)
end

function perform_step!(integrator, cache::ETD2Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; lin, nl, nlprev) = integrator.fsalfirst
    (; utmp, rtmp1, rtmp2, exphA, phihA, B1, B0) = cache
    @.. broadcast = false integrator.k[1] = lin + nl

    if integrator.iter == 1 # ETD1 for initial step
        mul!(utmp, exphA, uprev)
        mul!(rtmp1, phihA, nl)
        @muladd @.. broadcast = false u = utmp + dt * rtmp1
    else
        mul!(utmp, exphA, uprev)
        mul!(rtmp1, B1, nl)
        mul!(rtmp2, B0, nlprev)
        @muladd @.. broadcast = false u = utmp + dt * (rtmp1 + rtmp2)
    end

    # Push the fsal at t+dt
    fsallast = integrator.fsallast
    fsallast.nlprev .= nl
    f.f1(fsallast.lin, u, p, t + dt)
    f.f2(fsallast.nl, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.stats.nf2 += 1
    return @.. broadcast = false integrator.k[2] = fsallast.lin + fsallast.nl
end

#################################################
# Classical ExpRK method caches
abstract type ExpRKCache <: OrdinaryDiffEqMutableCache end
abstract type ExpRKConstantCache <: OrdinaryDiffEqConstantCache end
get_fsalfirstlast(cache::ExpRKCache, u) = (zero(cache.rtmp), zero(cache.rtmp))

# Precomputation of exponential-like operators
"""
    expRK_operators(alg,dt,A) -> ops

Compute operator(s) for an ExpRK algorithm. `dt` is the time step and `A` is
the matrix form of the linear operator (from either a linear problem or a
SplitODEProblem). All ExpRK methods that use caching operators should implement
this method.
"""
function expRK_operators(alg::ExponentialAlgorithm, dt, A)
    error("$alg does not support caching operators at the moment.")
end
expRK_operators(::LawsonEuler, dt, A) = exp(dt * A)
expRK_operators(::NorsettEuler, dt, A) = phi(dt * A, 1)[2]
function expRK_operators(::ETDRK2, dt, A)
    P = phi(dt * A, 2)
    return P[2], P[3] # ϕ1(hA), ϕ2(hA)
end
function expRK_operators(::ETDRK3, dt, A)
    Phalf = phi(dt / 2 * A, 1)
    A21 = 0.5Phalf[2]
    P = phi(dt * A, 3)
    phi1, phi2, phi3 = P[2], P[3], P[4]
    A3 = phi1
    B1 = 4phi3 - 3phi2 + phi1
    B2 = -8phi3 + 4phi2
    B3 = 4phi3 - phi2
    return A21, A3, B1, B2, B3
end
function expRK_operators(::ETDRK4, dt, A)
    P = phi(dt * A, 3)
    Phalf = phi(dt / 2 * A, 1)
    A21 = 0.5Phalf[2] # A32 = A21
    A41 = (dt / 4 * A) * Phalf[2]^2
    A43 = Phalf[2]
    B1 = P[2] - 3P[3] + 4P[4]
    B2 = 2P[3] - 4P[4] # B3 = B2
    B4 = -P[3] + 4P[4]
    return A21, A41, A43, B1, B2, B4
end
function expRK_operators(::HochOst4, dt, A)
    P = phi(dt * A, 3)
    Phalf = phi(dt / 2 * A, 3)
    A21 = 0.5Phalf[2]
    A31 = A21 - Phalf[3]
    A32 = Phalf[3]
    A41 = P[2] - 2P[3]
    A42 = P[3]
    A52 = 0.5Phalf[3] - P[4] + 0.25P[3] - 0.5Phalf[4]
    A54 = 0.25Phalf[3] - A52
    A51 = 0.5Phalf[2] - 2A52 - A54
    B1 = P[2] - 3P[3] + 4P[4]
    B4 = -P[3] + 4P[4]
    B5 = 4P[3] - 8P[4]
    return A21, A31, A32, A41, A42, A51, A52, A54, B1, B4, B5
end

# Unified constructor for constant caches
for (Alg, Cache) in [
        (:LawsonEuler, :LawsonEulerConstantCache),
        (:NorsettEuler, :NorsettEulerConstantCache),
        (:ETDRK2, :ETDRK2ConstantCache),
        (:ETDRK3, :ETDRK3ConstantCache),
        (:ETDRK4, :ETDRK4ConstantCache),
        (:HochOst4, :HochOst4ConstantCache),
    ]
    @eval struct $Cache{opType, FType} <: ExpRKConstantCache
        ops::opType # precomputed operators
        uf::FType   # derivative wrapper
    end

    @eval function alg_cache(
            alg::$Alg, u, rate_prototype, ::Type{uEltypeNoUnits},
            ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev,
            uprev2, f, t, dt, reltol, p, calck,
            ::Val{false}, verbose
        ) where {
            uEltypeNoUnits, uBottomEltypeNoUnits,
            tTypeNoUnits,
        }
        if alg.krylov
            ops = nothing # no caching
        else
            isa(f, SplitFunction) ||
                throw(ArgumentError("Caching can only be used with SplitFunction"))
            A = size(f.f1.f) == () ? convert(Number, f.f1.f) :
                convert(AbstractMatrix, f.f1.f)
            ops = expRK_operators(alg, dt, A)
        end
        if isa(f, SplitFunction) || SciMLBase.has_jac(f)
            uf = nothing
        else
            uf = UDerivativeWrapper(f, t, p)
        end
        return $Cache(ops, uf)
    end
end

"""
    alg_cache_expRK(alg,u,uEltypeNoUnits,uprev,f,t,dt,p,du1,tmp,dz,plist)

Construct the non-standard caches (not uType or rateType) for ExpRK integrators.

`plist` is a list of integers each corresponding to the order of a `phiv(!)`
call in `perform_step!`.
"""
function alg_cache_expRK(
        alg::OrdinaryDiffEqExponentialAlgorithm, u, ::Type{uEltypeNoUnits},
        uprev, f, t, dt, p, du1, tmp, dz, plist
    ) where {uEltypeNoUnits}
    n = length(u)
    T = eltype(u)
    # Allocate cache for ForwardDiff
    if isa(f, SplitFunction) || SciMLBase.has_jac(f)
        uf = nothing
        jac_config = nothing
    else
        uf = UJacobianWrapper(f, t, p)
        jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dz)
    end
    # Allocate cache for the Jacobian
    if isa(f, SplitFunction)
        J = nothing
    elseif SciMLBase.has_jac(f) && f.jac_prototype !== nothing
        J = deepcopy(f.jac_prototype)
    else
        J = fill(zero(uEltypeNoUnits), n, n)
    end
    if alg.krylov
        ops = nothing # no caching
        # Build up caches used by Krylov phiv
        m = min(alg.m, n)
        Ks = KrylovSubspace{T}(n, m)
        phiv_cache = PhivCache(u, m, maximum(plist))
        ws = [Matrix{T}(undef, n, plist[i] + 1) for i in 1:length(plist)]
        KsCache = (Ks, phiv_cache, ws)
    else
        KsCache = nothing
        # Precompute the operators
        A = size(f.f1.f) == () ? convert(Number, f.f1.f) : convert(AbstractMatrix, f.f1.f)
        ops = expRK_operators(alg, dt, A)
    end
    return uf, jac_config, J, ops, KsCache
end

@cache struct LawsonEulerCache{uType, rateType, JCType, FType, JType, expType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    G::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    J::JType
    exphA::expType
    KsCache::KsType
end

function alg_cache(
        alg::LawsonEuler, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz = (zero(u) for i in 1:2)                            # uType caches
    rtmp, G, du1 = (zero(rate_prototype) for i in 1:3)             # rateType caches
    # other caches
    # This is different from other ExpRK integrators because LawsonEuler only
    # needs expv.
    n = length(u)
    T = eltype(u)
    # Allocate caches for ForwardDiff
    if isa(f, SplitFunction) || SciMLBase.has_jac(f)
        uf = nothing
        jac_config = nothing
    else
        uf = UJacobianWrapper(f, t, p)
        jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dz)
    end
    # Allocate cache for the Jacobian
    if isa(f, SplitFunction)
        J = nothing
    elseif SciMLBase.has_jac(f) && f.jac_prototype !== nothing
        J = deepcopy(f.jac_prototype)
    else
        J = fill(zero(uEltypeNoUnits), n, n)
    end
    if alg.krylov
        exphA = nothing # no caching
        m = min(alg.m, n)
        Ks = KrylovSubspace{T}(n, m)
        expv_cache = ExpvCache{T}(m)
        KsCache = (Ks, expv_cache)
    else
        KsCache = nothing
        A = size(f.f1.f) == () ? convert(Number, f.f1.f) : convert(AbstractMatrix, f.f1.f)
        exphA = expRK_operators(alg, dt, A)
    end
    return LawsonEulerCache(u, uprev, tmp, dz, rtmp, G, du1, jac_config, uf, J, exphA, KsCache)
end

@cache struct NorsettEulerCache{uType, rateType, JCType, FType, JType, expType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    G::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    J::JType
    phihA::expType
    KsCache::KsType
end

function alg_cache(
        alg::NorsettEuler, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz = (zero(u) for i in 1:2)                # uType caches
    rtmp, G, du1 = (zero(rate_prototype) for i in 1:3) # rateType caches
    plist = (1,)
    uf, jac_config,
        J,
        phihA,
        KsCache = alg_cache_expRK(
        alg, u, uEltypeNoUnits, uprev, f, t,
        dt, p, du1, tmp, dz, plist
    ) # other caches
    return NorsettEulerCache(u, uprev, tmp, dz, rtmp, G, du1, jac_config, uf, J, phihA, KsCache)
end

@cache struct ETDRK2Cache{uType, rateType, JCType, FType, JType, opType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    F2::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    J::JType
    ops::opType
    KsCache::KsType
end

function alg_cache(
        alg::ETDRK2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz = (zero(u) for i in 1:2)                 # uType caches
    rtmp, F2, du1 = (zero(rate_prototype) for i in 1:3) # rateType caches
    plist = (2, 2)
    uf, jac_config,
        J,
        ops,
        KsCache = alg_cache_expRK(
        alg, u, uEltypeNoUnits, uprev, f, t,
        dt, p, du1, tmp, dz, plist
    ) # other caches
    return ETDRK2Cache(u, uprev, tmp, dz, rtmp, F2, du1, jac_config, uf, J, ops, KsCache)
end

@cache struct ETDRK3Cache{uType, rateType, JCType, FType, JType, opType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    Au::rateType
    F2::rateType
    F3::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    J::JType
    ops::opType
    KsCache::KsType
end

function alg_cache(
        alg::ETDRK3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz = (zero(u) for i in 1:2)                         # uType caches
    rtmp, Au, F2, F3, du1 = (zero(rate_prototype) for i in 1:5) # rateType caches
    plist = (1, 3, 3, 3)
    uf, jac_config,
        J,
        ops,
        KsCache = alg_cache_expRK(
        alg, u, uEltypeNoUnits, uprev, f, t,
        dt, p, du1, tmp, dz, plist
    ) # other caches
    return ETDRK3Cache(u, uprev, tmp, dz, rtmp, Au, F2, F3, du1, jac_config, uf, J, ops, KsCache)
end

@cache struct ETDRK4Cache{uType, rateType, JCType, FType, JType, opType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    Au::rateType
    F2::rateType
    F3::rateType
    F4::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    J::JType
    ops::opType
    KsCache::KsType
end

function alg_cache(
        alg::ETDRK4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz = (zero(u) for i in 1:2)                             # uType caches
    rtmp, Au, F2, F3, F4, du1 = (zero(rate_prototype) for i in 1:6) # rateType caches
    plist = (1, 1, 3, 3, 3, 3)
    uf, jac_config,
        J,
        ops,
        KsCache = alg_cache_expRK(
        alg, u, uEltypeNoUnits, uprev, f, t,
        dt, p, du1, tmp, dz, plist
    ) # other caches
    return ETDRK4Cache(
        u, uprev, tmp, dz, rtmp, Au, F2, F3, F4, du1, jac_config, uf, J, ops,
        KsCache
    )
end

@cache struct HochOst4Cache{uType, rateType, JCType, FType, JType, opType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    rtmp2::rateType
    Au::rateType
    F2::rateType
    F3::rateType
    F4::rateType
    F5::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    J::JType
    ops::opType
    KsCache::KsType
end

function alg_cache(
        alg::HochOst4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz = (zero(u) for i in 1:2)                                        # uType caches
    rtmp, rtmp2, Au, F2, F3, F4, F5, du1 = (zero(rate_prototype) for i in 1:8) # rateType caches
    plist = (3, 3, 3, 3, 3, 3, 3, 3, 3)
    uf, jac_config,
        J,
        ops,
        KsCache = alg_cache_expRK(
        alg, u, uEltypeNoUnits, uprev, f, t,
        dt, p, du1, tmp, dz, plist
    ) # other caches
    return HochOst4Cache(
        u, uprev, tmp, dz, rtmp, rtmp2, Au, F2, F3, F4, F5, du1, jac_config, uf,
        J, ops, KsCache
    )
end

####################################
# EPIRK method caches
function _phiv_timestep_caches(u_prototype, maxiter::Int, p::Int)
    n = length(u_prototype)
    T = eltype(u_prototype)
    u = zero(u_prototype)                         # stores the current state
    W = Matrix{T}(undef, n, p + 1)                  # stores the w vectors
    P = Matrix{T}(undef, n, p + 2)                  # stores output from phiv!
    Ks = KrylovSubspace{T}(n, maxiter)            # stores output from arnoldi!
    phiv_cache = PhivCache(u_prototype, maxiter, p + 1) # cache used by phiv! (need +1 for error estimation)
    return u, W, P, Ks, phiv_cache
end

# Unified constructor for constant caches
for (Alg, Cache) in [
        (:Exp4, :Exp4ConstantCache),
        (:EPIRK4s3A, :EPIRK4s3AConstantCache),
        (:EPIRK4s3B, :EPIRK4s3BConstantCache),
        (:EPIRK5s3, :EPIRK5s3ConstantCache),
        (:EXPRB53s3, :EXPRB53s3ConstantCache),
        (:EPIRK5P1, :EPIRK5P1ConstantCache),
        (:EPIRK5P2, :EPIRK5P2ConstantCache),
    ]
    @eval struct $Cache{FType} <: ExpRKConstantCache
        uf::FType   # derivative wrapper
    end
    @eval function alg_cache(
            alg::$Alg, u, rate_prototype, ::Type{uEltypeNoUnits},
            ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev,
            uprev2, f, t, dt, reltol, p, calck,
            ::Val{false}, verbose
        ) where {
            uEltypeNoUnits, uBottomEltypeNoUnits,
            tTypeNoUnits,
        }
        if SciMLBase.has_jac(f)
            uf = nothing
        else
            uf = UDerivativeWrapper(f, t, p)
        end
        return $Cache(uf)
    end
end

@cache struct Exp4Cache{uType, rateType, JCType, FType, matType, JType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    rtmp2::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    K::matType
    J::JType
    B::matType
    KsCache::KsType
end
function alg_cache(
        alg::Exp4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz = (zero(u) for i in 1:2)                    # uType caches
    rtmp, rtmp2, du1 = (zero(rate_prototype) for i in 1:3) # rateType caches
    # Allocate jacobian and caches for ForwardDiff
    if SciMLBase.has_jac(f)
        uf = nothing
        jac_config = nothing
    else
        uf = UJacobianWrapper(f, t, p)
        jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dz)
    end
    if SciMLBase.has_jac(f) && f.jac_prototype !== nothing
        J = deepcopy(f.jac_prototype)
    else
        J = fill(zero(uEltypeNoUnits), length(u), length(u))
    end
    # Allocate matrices
    # TODO: units
    n = length(u)
    T = eltype(u)
    K = Matrix{T}(undef, n, 3)
    B = fill(zero(T), n, 2)
    # Allocate caches for phiv_timestep
    maxiter = min(alg.m, n)
    KsCache = _phiv_timestep_caches(u, maxiter, 1)
    return Exp4Cache(u, uprev, tmp, dz, rtmp, rtmp2, du1, jac_config, uf, K, J, B, KsCache)
end

@cache struct EPIRK4s3ACache{uType, rateType, JCType, FType, matType, JType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    rtmp2::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    K::matType
    J::JType
    B::matType
    KsCache::KsType
end
function alg_cache(
        alg::EPIRK4s3A, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz = (zero(u) for i in 1:2)                    # uType caches
    rtmp, rtmp2, du1 = (zero(rate_prototype) for i in 1:3) # rateType caches
    # Allocate jacobian and caches for ForwardDiff
    if SciMLBase.has_jac(f)
        uf = nothing
        jac_config = nothing
    else
        uf = UJacobianWrapper(f, t, p)
        jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dz)
    end
    if SciMLBase.has_jac(f) && f.jac_prototype !== nothing
        J = deepcopy(f.jac_prototype)
    else
        J = fill(zero(uEltypeNoUnits), length(u), length(u))
    end
    # Allocate matrices
    n = length(u)
    T = eltype(u)
    K = Matrix{T}(undef, n, 2)
    B = fill(zero(T), n, 5)
    # Allocate caches for phiv_timestep
    maxiter = min(alg.m, n)
    KsCache = _phiv_timestep_caches(u, maxiter, 4)
    return EPIRK4s3ACache(u, uprev, tmp, dz, rtmp, rtmp2, du1, jac_config, uf, K, J, B, KsCache)
end

@cache struct EPIRK4s3BCache{uType, rateType, JCType, FType, matType, JType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    rtmp2::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    K::matType
    J::JType
    B::matType
    KsCache::KsType
end
function alg_cache(
        alg::EPIRK4s3B, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz = (zero(u) for i in 1:2)                    # uType caches
    rtmp, rtmp2, du1 = (zero(rate_prototype) for i in 1:3) # rateType caches
    # Allocate jacobian and caches for ForwardDiff
    if SciMLBase.has_jac(f)
        uf = nothing
        jac_config = nothing
    else
        uf = UJacobianWrapper(f, t, p)
        jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dz)
    end
    if SciMLBase.has_jac(f) && f.jac_prototype !== nothing
        J = deepcopy(f.jac_prototype)
    else
        J = fill(zero(uEltypeNoUnits), length(u), length(u))
    end
    # Allocate matrices
    n = length(u)
    T = eltype(u)
    K = Matrix{T}(undef, n, 2)
    B = fill(zero(T), n, 5)
    # Allocate caches for phiv_timestep
    maxiter = min(alg.m, n)
    KsCache = _phiv_timestep_caches(u, maxiter, 4)
    return EPIRK4s3BCache(u, uprev, tmp, dz, rtmp, rtmp2, du1, jac_config, uf, K, J, B, KsCache)
end

@cache struct EPIRK5s3Cache{uType, rateType, JCType, FType, matType, JType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    k::uType
    rtmp::rateType
    rtmp2::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    J::JType
    B::matType
    KsCache::KsType
end
function alg_cache(
        alg::EPIRK5s3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz, k = (zero(u) for i in 1:3)                 # uType caches
    rtmp, rtmp2, du1 = (zero(rate_prototype) for i in 1:3) # rateType caches
    # Allocate jacobian and caches for ForwardDiff
    if SciMLBase.has_jac(f)
        uf = nothing
        jac_config = nothing
    else
        uf = UJacobianWrapper(f, t, p)
        jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dz)
    end
    if SciMLBase.has_jac(f) && f.jac_prototype !== nothing
        J = deepcopy(f.jac_prototype)
    else
        J = fill(zero(uEltypeNoUnits), length(u), length(u))
    end
    # Allocate matrices
    n = length(u)
    T = eltype(u)
    B = fill(zero(T), n, 5)
    # Allocate caches for phiv_timestep
    maxiter = min(alg.m, n)
    KsCache = _phiv_timestep_caches(u, maxiter, 4)
    return EPIRK5s3Cache(u, uprev, tmp, dz, k, rtmp, rtmp2, du1, jac_config, uf, J, B, KsCache)
end

@cache struct EXPRB53s3Cache{uType, rateType, JCType, FType, matType, JType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    rtmp2::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    K::matType
    J::JType
    B::matType
    KsCache::KsType
end
function alg_cache(
        alg::EXPRB53s3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz = (zero(u) for i in 1:2)                    # uType caches
    rtmp, rtmp2, du1 = (zero(rate_prototype) for i in 1:3) # rateType caches
    # Allocate jacobian and caches for ForwardDiff
    if SciMLBase.has_jac(f)
        uf = nothing
        jac_config = nothing
    else
        uf = UJacobianWrapper(f, t, p)
        jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dz)
    end
    if SciMLBase.has_jac(f) && f.jac_prototype !== nothing
        J = deepcopy(f.jac_prototype)
    else
        J = fill(zero(uEltypeNoUnits), length(u), length(u))
    end
    # Allocate matrices
    n = length(u)
    T = eltype(u)
    K = Matrix{T}(undef, n, 2)
    B = fill(zero(T), n, 5)
    # Allocate caches for phiv_timestep
    maxiter = min(alg.m, n)
    KsCache = _phiv_timestep_caches(u, maxiter, 4)
    return EXPRB53s3Cache(u, uprev, tmp, dz, rtmp, rtmp2, du1, jac_config, uf, K, J, B, KsCache)
end

@cache struct EPIRK5P1Cache{uType, rateType, JCType, FType, matType, JType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    rtmp2::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    K::matType
    J::JType
    B::matType
    KsCache::KsType
end
function alg_cache(
        alg::EPIRK5P1, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz = (zero(u) for i in 1:2)                    # uType caches
    rtmp, rtmp2, du1 = (zero(rate_prototype) for i in 1:3) # rateType caches
    # Allocate jacobian and caches for ForwardDiff
    if SciMLBase.has_jac(f)
        uf = nothing
        jac_config = nothing
    else
        uf = UJacobianWrapper(f, t, p)
        jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dz)
    end
    if SciMLBase.has_jac(f) && f.jac_prototype !== nothing
        J = deepcopy(f.jac_prototype)
    else
        J = fill(zero(uEltypeNoUnits), length(u), length(u))
    end
    # Allocate matrices
    n = length(u)
    T = eltype(u)
    K = Matrix{T}(undef, n, 3)
    B = fill(zero(T), n, 4)
    # Allocate caches for phiv_timestep
    maxiter = min(alg.m, n)
    KsCache = _phiv_timestep_caches(u, maxiter, 3)
    return EPIRK5P1Cache(u, uprev, tmp, dz, rtmp, rtmp2, du1, jac_config, uf, K, J, B, KsCache)
end

@cache struct EPIRK5P2Cache{uType, rateType, JCType, FType, matType, JType, KsType} <:
    ExpRKCache
    u::uType
    uprev::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    rtmp2::rateType
    dR::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    K::matType
    J::JType
    B::matType
    KsCache::KsType
end
function alg_cache(
        alg::EPIRK5P2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp, dz = (zero(u) for i in 1:2)                        # uType caches
    rtmp, rtmp2, dR, du1 = (zero(rate_prototype) for i in 1:4) # rateType caches
    # Allocate jacobian and caches for ForwardDiff
    if SciMLBase.has_jac(f)
        uf = nothing
        jac_config = nothing
    else
        uf = UJacobianWrapper(f, t, p)
        jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dz)
    end
    if SciMLBase.has_jac(f) && f.jac_prototype !== nothing
        J = deepcopy(f.jac_prototype)
    else
        J = fill(zero(uEltypeNoUnits), length(u), length(u))
    end
    # Allocate matrices
    n = length(u)
    T = eltype(u)
    K = Matrix{T}(undef, n, 3)
    B = fill(zero(T), n, 4)
    # Allocate caches for phiv_timestep
    maxiter = min(alg.m, n)
    KsCache = _phiv_timestep_caches(u, maxiter, 3)
    return EPIRK5P2Cache(u, uprev, tmp, dz, rtmp, rtmp2, dR, du1, jac_config, uf, K, J, B, KsCache)
end

####################################
# Adaptive exponential Rosenbrock method caches

## Constant caches
for (Alg, Cache) in [
        (:Exprb32, :Exprb32ConstantCache),
        (:Exprb43, :Exprb43ConstantCache),
    ]
    @eval struct $Cache{FType} <: ExpRKConstantCache
        uf::FType   # derivative wrapper
    end
    @eval function alg_cache(
            alg::$Alg, u, rate_prototype, ::Type{uEltypeNoUnits},
            ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev,
            uprev2, f, t, dt, reltol, p, calck,
            ::Val{false}, verbose
        ) where {
            uEltypeNoUnits, uBottomEltypeNoUnits,
            tTypeNoUnits,
        }
        if SciMLBase.has_jac(f)
            uf = nothing
        else
            uf = UDerivativeWrapper(f, t, p)
        end
        return $Cache(uf)
    end
end

## Mutable caches
"""
    alg_cache_exprb(alg,uEltypeNoUnits,uprev,f,t,p,du1,tmp,dz,plist)

Construct the non-standard caches (not uType or rateType) for Exprb integrators.

`plist` is a list of integers each corresponding to the order of a `phiv(!)`
call in `perform_step!`.
"""
function alg_cache_exprb(
        alg::OrdinaryDiffEqAdaptiveExponentialAlgorithm, u,
        ::Type{uEltypeNoUnits}, uprev, f, t, p, du1, tmp, dz,
        plist
    ) where {uEltypeNoUnits}
    if f isa SplitFunction
        error("Algorithm $alg cannot be used for split problems. Consider reformat to a regular `ODEProblem`")
    end
    n = length(u)
    T = eltype(u)
    # Allocate cache for ForwardDiff
    if SciMLBase.has_jac(f)
        uf = nothing
        jac_config = nothing
    else
        uf = UJacobianWrapper(f, t, p)
        jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dz)
    end
    # Allocate cache for the Jacobian
    if SciMLBase.has_jac(f) && f.jac_prototype !== nothing
        J = deepcopy(f.jac_prototype)
    else
        J = fill(zero(uEltypeNoUnits), n, n)
    end
    # Build up caches used by Krylov phiv
    m = min(alg.m, n)
    Ks = KrylovSubspace{T}(n, m)
    phiv_cache = PhivCache(u, m, maximum(plist))
    ws = [Matrix{T}(undef, n, plist[i] + 1) for i in 1:length(plist)]
    KsCache = (Ks, phiv_cache, ws)
    return uf, jac_config, J, KsCache
end

@cache struct Exprb32Cache{uType, rateType, JCType, FType, JType, KsType} <: ExpRKCache
    u::uType
    uprev::uType
    utilde::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    F2::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    J::JType
    KsCache::KsType
end
function alg_cache(
        alg::Exprb32, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    utilde, tmp, dz = (zero(u) for i in 1:3)         # uType caches
    rtmp, F2, du1 = (zero(rate_prototype) for i in 1:3) # rateType caches
    plist = (3, 3)
    uf, jac_config,
        J,
        KsCache = alg_cache_exprb(
        alg, u, uEltypeNoUnits, uprev, f, t, p,
        du1, tmp, dz, plist
    ) # other caches
    return Exprb32Cache(u, uprev, utilde, tmp, dz, rtmp, F2, du1, jac_config, uf, J, KsCache)
end

struct Exprb43Cache{uType, rateType, JCType, FType, JType, KsType} <: ExpRKCache
    u::uType
    uprev::uType
    utilde::uType
    tmp::uType
    dz::uType
    rtmp::rateType
    Au::rateType
    F2::rateType
    F3::rateType
    du1::rateType
    jac_config::JCType
    uf::FType
    J::JType
    KsCache::KsType
end
function alg_cache(
        alg::Exprb43, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    utilde, tmp, dz = (zero(u) for i in 1:3)                 # uType caches
    rtmp, Au, F2, F3, du1 = (zero(rate_prototype) for i in 1:5) # rateType caches
    plist = (1, 4, 4, 4)
    uf, jac_config,
        J,
        KsCache = alg_cache_exprb(
        alg, u, uEltypeNoUnits, uprev, f, t, p,
        du1, tmp, dz, plist
    ) # other caches
    return Exprb43Cache(
        u, uprev, utilde, tmp, dz, rtmp, Au, F2, F3, du1, jac_config, uf, J,
        KsCache
    )
end

####################################
# Multistep exponential method caches

#=
  Fsal separately the linear and nonlinear part, as well as the nonlinear
  part in the previous time step.
=#
mutable struct ETD2Fsal{rateType}
    lin::rateType
    nl::rateType
    nlprev::rateType

    function ETD2Fsal(lin, nl, nlprev)
        if size(lin) == ()
            # convert to same type if Number or AbstractSciMLScalarOperator
            T = promote_type(eltype.((lin, nl, nlprev))...)

            lin = convert(T, lin)
            nl = convert(T, nl)
            nlprev = convert(T, nlprev)
        end

        return new{typeof(lin)}(lin, nl, nlprev)
    end
end
function ETD2Fsal(rate_prototype)
    return ETD2Fsal(zero(rate_prototype), zero(rate_prototype), zero(rate_prototype))
end
function recursivecopy!(dest::ETD2Fsal, src::ETD2Fsal)
    recursivecopy!(dest.lin, src.lin)
    recursivecopy!(dest.nl, src.nl)
    return recursivecopy!(dest.nlprev, src.nlprev)
end

struct ETD2ConstantCache{expType} <: OrdinaryDiffEqConstantCache
    exphA::expType
    phihA::expType
    B1::expType # ϕ1(hA) + ϕ2(hA)
    B0::expType # -ϕ2(hA)
end

get_fsalfirstlast(cache::ETD2ConstantCache, u) = (ETD2Fsal(u), ETD2Fsal(u))

function alg_cache(
        alg::ETD2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    A = size(f.f1.f) == () ? convert(Number, f.f1.f) : convert(AbstractMatrix, f.f1.f)
    Phi = phi(dt * A, 2)
    return ETD2ConstantCache(Phi[1], Phi[2], Phi[2] + Phi[3], -Phi[3])
end

@cache struct ETD2Cache{uType, rateType, expType} <: OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    utmp::uType
    rtmp1::rateType
    rtmp2::rateType
    exphA::expType
    phihA::expType
    B1::expType # ϕ1(hA) + ϕ2(hA)
    B0::expType # -ϕ2(hA)
end
get_fsalfirstlast(cache::ETD2Cache, u) = (ETD2Fsal(cache.rtmp1), ETD2Fsal(cache.rtmp1))

function alg_cache(
        alg::ETD2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    A = size(f.f1.f) == () ? convert(Number, f.f1.f) : convert(AbstractMatrix, f.f1.f)
    Phi = phi(dt * A, 2)
    return ETD2Cache(
        u, uprev, zero(u), zero(rate_prototype), zero(rate_prototype), Phi[1], Phi[2],
        Phi[2] + Phi[3], -Phi[3]
    )
end

using OrdinaryDiffEqExponentialRK, Test, DiffEqDevTools, Random, LinearAlgebra, LinearSolve
using OrdinaryDiffEqVerner, OrdinaryDiffEqSDIRK
using OrdinaryDiffEqCore: alg_order

@testset "Caching Out-of-place" begin
    println("Caching Out-of-place")
    μ = 1.01
    linnonlin_f2 = (u, p, t) -> μ * u
    linnonlin_f1 = ScalarOperator(μ)
    linnonlin_fun = SplitFunction(
        linnonlin_f1, linnonlin_f2;
        analytic = (u0, p, t) -> u0 .* exp.(2μ * t)
    )
    prob = SplitODEProblem(linnonlin_fun, 1 / 2, (0.0, 1.0))

    Random.seed!(100)
    dts = 1 ./ 2 .^ (7:-1:4) #14->7 good plot
    for Alg in [
            LawsonEuler,
            NorsettEuler,
            ETDRK2,
            ETDRK3,
            ETDRK4,
            HochOst4,
            ETD2,
            KenCarp3,
            CFNLIRK3,
        ]
        sim = test_convergence(dts, prob, Alg())
        @test sim.𝒪est[:l2] ≈ alg_order(Alg()) atol = 0.2
    end

    # Dense test
    sim = test_convergence(dts, prob, ETDRK4(), dense_errors = true)
    @test abs(sim.𝒪est[:l2] - 4) < 0.2
end

@testset "Caching Inplace" begin
    println("Caching Inplace")
    μ = 1.01
    u0 = rand(2)
    A = [2.0 -1.0; -1.0 2.0]
    linnonlin_f1 = MatrixOperator(A)
    linnonlin_f2 = (du, u, p, t) -> du .= μ .* u
    linnonlin_fun_iip = SplitFunction(
        linnonlin_f1, linnonlin_f2;
        analytic = (u0, p, t) -> exp((A + μ * I) * t) * u0
    )
    prob = SplitODEProblem(linnonlin_fun_iip, u0, (0.0, 1.0))

    dts = 1 ./ 2 .^ (8:-1:4)
    for Alg in [
            LawsonEuler(),
            NorsettEuler(),
            ETDRK2(),
            ETDRK3(),
            ETDRK4(),
            HochOst4(),
            ETD2(),
        ]
        sim = test_convergence(dts, prob, Alg)
        @test sim.𝒪est[:l2] ≈ alg_order(Alg) atol = 0.15
    end

    dts = 1 ./ 2 .^ (13:-1:9)
    Alg = KenCarp3(linsolve = LinearSolve.KrylovJL_GMRES())
    sim = test_convergence(dts, prob, Alg, reltol = 1.0e-16)
    @test sim.𝒪est[:l2] ≈ alg_order(Alg) atol = 0.5

    dts = 1 ./ 2 .^ (8:-1:4)
    sim = test_convergence(dts, prob, ETDRK4(), dense_errors = true)
    @test sim.𝒪est[:l2] ≈ 4 atol = 0.1
    @test sim.𝒪est[:L2] ≈ 4 atol = 0.1
end

@info "CFNLIRK3() is broken"

@testset "EPIRK Out-of-place" begin
    println("EPIRK Out-of-place")
    # Setup nonlinear problem
    A = [-2.0 1.0; 1.0 -2.0]
    f = (u, p, t) -> A * u - u .^ 3
    jac = (u, p, t) -> A - [3u[1]^2 0.0; 0.0 3u[2]^2]
    fun = ODEFunction(f; jac = jac)
    Random.seed!(0)
    u0 = rand(2)
    tspan = (0.0, 1.0)
    prob = ODEProblem(fun, u0, tspan)
    # Setup approximate solution
    test_setup = Dict(:alg => Vern9(), :reltol => 1.0e-16, :abstol => 1.0e-16)
    # Convergence simulation
    dts = 1 ./ 2 .^ (7:-1:4)
    Algs = [Exp4, EPIRK4s3A, EPIRK4s3B, EPIRK5s3, EXPRB53s3, EPIRK5P1, EPIRK5P2]
    for Alg in Algs
        sim = analyticless_test_convergence(
            dts, prob, Alg(adaptive_krylov = false),
            test_setup
        )
        if Alg == EPIRK5s3
            @test_broken sim.𝒪est[:l2] ≈ alg_order(Alg()) atol = 0.1
        else
            @test sim.𝒪est[:l2] ≈ alg_order(Alg()) atol = 0.1
        end
    end
end

@testset "EPIRK Inplace" begin
    println("EPIRK Inplace")
    # Setup nonlinear problem
    A = [-2.0 1.0; 1.0 -2.0]
    f = (du, u, p, t) -> (mul!(du, A, u); du .-= u .^ 3)
    jac_update! = (J, u, p, t) -> (copyto!(J, A); J[1, 1] -= 3u[1]^2; J[2, 2] -= 3u[2]^2)
    jac_prototype = MatrixOperator(zeros(2, 2); update_func! = jac_update!)
    fun = ODEFunction(f; jac_prototype = jac_prototype)
    Random.seed!(0)
    u0 = rand(2)
    tspan = (0.0, 1.0)
    prob = ODEProblem(fun, u0, tspan)
    # Setup approximate solution
    test_setup = Dict(:alg => Vern9(), :reltol => 1.0e-16, :abstol => 1.0e-16)
    # Convergence simulation
    dts = 1 ./ 2 .^ (7:-1:4)
    Algs = [Exp4, EPIRK4s3A, EPIRK4s3B, EPIRK5s3, EXPRB53s3, EPIRK5P1, EPIRK5P2]
    for Alg in Algs
        sim = analyticless_test_convergence(
            dts, prob, Alg(adaptive_krylov = false),
            test_setup
        )
        if Alg == EPIRK5s3
            @test_broken sim.𝒪est[:l2] ≈ alg_order(Alg()) atol = 0.1
        else
            @test sim.𝒪est[:l2] ≈ alg_order(Alg()) atol = 0.1
        end
    end
end

@testset "ExpRK Autodiff" begin
    println("ExpRK Autodiff")
    # Setup nonlinear problem (without explicit jacobian)
    A = [-2.0 1.0; 1.0 -2.0]
    f = (u, p, t) -> A * u - u .^ 3
    f_ip = (du, u, p, t) -> (mul!(du, A, u); du .-= u .^ 3)
    fun = ODEFunction(f)
    fun_ip = ODEFunction(f_ip)
    Random.seed!(0)
    u0 = rand(2)
    tspan = (0.0, 1.0)
    prob = ODEProblem(fun, u0, tspan)
    prob_ip = ODEProblem(fun_ip, u0, tspan)
    # Setup approximate solution
    test_setup = Dict(:alg => Vern9(), :reltol => 1.0e-16, :abstol => 1.0e-16)
    # Convergence simulation
    dts = 1 ./ 2 .^ (7:-1:4)
    sim = analyticless_test_convergence(dts, prob, HochOst4(krylov = true), test_setup)
    @test sim.𝒪est[:l2] ≈ 4 atol = 0.1
    sim = analyticless_test_convergence(dts, prob_ip, HochOst4(krylov = true), test_setup)
    @test sim.𝒪est[:l2] ≈ 4 atol = 0.1
    sim = analyticless_test_convergence(
        dts, prob, EPIRK5P1(adaptive_krylov = false),
        test_setup
    )
    @test sim.𝒪est[:l2] ≈ 5 atol = 0.1
    sim = analyticless_test_convergence(
        dts, prob_ip, EPIRK5P1(adaptive_krylov = false),
        test_setup
    )
    @test sim.𝒪est[:l2] ≈ 5 atol = 0.1
end

@testset "Adaptive Exprb Out-of-place" begin
    println("Adaptive Exprb Out-of-place")
    # Setup nonlinear problem
    A = [-2.0 1.0; 1.0 -2.0]
    f = (u, p, t) -> A * u - u .^ 3
    jac = (u, p, t) -> A - [3u[1]^2 0.0; 0.0 3u[2]^2]
    fun = ODEFunction(f; jac = jac)
    Random.seed!(0)
    u0 = rand(2)
    tspan = (0.0, 1.0)
    prob = ODEProblem(fun, u0, tspan)
    # Setup approximate solution
    test_setup = Dict(:alg => Vern9(), :reltol => 1.0e-16, :abstol => 1.0e-16)
    # Convergence simulation
    dts = 1 ./ 2 .^ (7:-1:4)
    Algs = [Exprb32, Exprb43]
    for Alg in Algs
        sim = analyticless_test_convergence(dts, prob, Alg(), test_setup)
        @test sim.𝒪est[:l2] ≈ alg_order(Alg()) atol = 0.1
    end
end

@testset "Adaptive Exprb Inplace" begin
    println("Adaptive Exprb Inplace")
    # Setup nonlinear problem
    A = [-2.0 1.0; 1.0 -2.0]
    f = (du, u, p, t) -> (mul!(du, A, u); du .-= u .^ 3)
    jac_update! = (J, u, p, t) -> (copyto!(J, A); J[1, 1] -= 3u[1]^2; J[2, 2] -= 3u[2]^2)
    jac_prototype = MatrixOperator(zeros(2, 2); update_func! = jac_update!)
    fun = ODEFunction(f; jac_prototype = jac_prototype)
    Random.seed!(0)
    u0 = rand(2)
    tspan = (0.0, 1.0)
    prob = ODEProblem(fun, u0, tspan)
    # Setup approximate solution
    test_setup = Dict(:alg => Vern9(), :reltol => 1.0e-16, :abstol => 1.0e-16)
    # Convergence simulation
    dts = 1 ./ 2 .^ (7:-1:4)
    Algs = [Exprb32, Exprb43]
    for Alg in Algs
        sim = analyticless_test_convergence(dts, prob, Alg(), test_setup)
        @test sim.𝒪est[:l2] ≈ alg_order(Alg()) atol = 0.1
    end
end

module OrdinaryDiffEqExponentialRK

import OrdinaryDiffEqCore: alg_order, alg_adaptive_order, ismultistep,
    OrdinaryDiffEqExponentialAlgorithm,
    _unwrap_val, OrdinaryDiffEqMutableCache,
    OrdinaryDiffEqConstantCache,
    @cache, alg_cache,
    initialize!, perform_step!, unwrap_alg,
    OrdinaryDiffEqAdaptiveExponentialAlgorithm, CompositeAlgorithm,
    ExponentialAlgorithm, fsal_typeof, isdtchangeable,
    calculate_residuals, calculate_residuals!,
    full_cache, get_fsalfirstlast,
    generic_solver_docstring, _bool_to_ADType, _process_AD_choice
import OrdinaryDiffEqCore
using RecursiveArrayTools
using MuladdMacro, FastBroadcast
using LinearAlgebra: axpy!, mul!
import DiffEqBase
import DiffEqBase: prepare_alg
using ExponentialUtilities
import RecursiveArrayTools: recursivecopy!
using OrdinaryDiffEqDifferentiation: build_jac_config, UJacobianWrapper, UDerivativeWrapper,
    calc_J, calc_J!
import ADTypes: AutoForwardDiff, AbstractADType

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("exponential_rk_caches.jl")
include("exponential_rk_perform_step.jl")

export LawsonEuler, NorsettEuler, ETD1, ETDRK2, ETDRK3, ETDRK4, HochOst4, Exp4, EPIRK4s3A,
    EPIRK4s3B,
    EPIRK5s3, EXPRB53s3, EPIRK5P1, EPIRK5P2, ETD2, Exprb32, Exprb43
end

REF1 = """
Hochbruck, Marlis, and Alexander Ostermann. “Exponential Integrators.” Acta
  Numerica 19 (2010): 209–286. doi:10.1017/S0962492910000048.
"""
for (Alg, Description, Ref) in [
        (:LawsonEuler, "First order exponential Euler scheme (fixed timestepping)", REF1),
        (:NorsettEuler, "First order exponential-RK scheme. Alias: `ETD1`", REF1),
        (:ETDRK2, "2nd order exponential-RK scheme.", REF1),
        (:ETDRK3, "3rd order exponential-RK scheme.", REF1),
        (:ETDRK4, "4th order exponential-RK scheme (fixed timestepping)", REF1),
        (:HochOst4, "4th order exponential-RK scheme with stiff order 4.", REF1),
    ]
    @eval begin
        @doc generic_solver_docstring(
            $Description,
            $(string(Alg)),
            "Semilinear ODE solver",
            $Ref,
            """
            - `krylov`: Determines whether Krylov approximation or operator caching is used, the latter only available for semilinear problems.
                `krylov=true` is much faster for larger systems and is thus recommended whenever there are >100 ODEs.
            - `m`: Controls the size of Krylov subspace.
            - `iop`: If not zero, determines the length of the incomplete orthogonalization procedure (IOP).
                    Note that if the linear operator/Jacobian is hermitian, then the Lanczos algorithm will always be used and the IOP setting is ignored.
            """,
            """
            krylov = false,
            m = 30,
            iop = 0,
            """
        )
        struct $Alg{CS, AD, FDT, ST, CJ} <:
            OrdinaryDiffEqExponentialAlgorithm{CS, AD, FDT, ST, CJ}
            krylov::Bool
            m::Int
            iop::Int
            autodiff::AD
        end
    end
    @eval function $Alg(;
            krylov = false, m = 30, iop = 0, autodiff = AutoForwardDiff(),
            standardtag = Val{true}(), concrete_jac = nothing,
            chunk_size = Val{0}(),
            diff_type = Val{:forward}()
        )
        AD_choice, chunk_size,
            diff_type = _process_AD_choice(
            autodiff, chunk_size, diff_type
        )

        return $Alg{
            _unwrap_val(chunk_size), typeof(AD_choice),
            diff_type, _unwrap_val(standardtag), _unwrap_val(concrete_jac),
        }(
            krylov,
            m,
            iop,
            AD_choice
        )
    end
end

const ETD1 = NorsettEuler # alias

REF2 = """
Hochbruck, M., & Ostermann, A. (2010). Exponential integrators. Acta Numerica, 19, 209-286. (https://doi.org/10.1017/S0962492910000048)
"""

for (Alg, Description, Ref) in [
        (:Exprb32, "3rd order adaptive Exponential-Rosenbrock scheme.", REF2),
        (:Exprb43, "4th order adaptive Exponential-Rosenbrock scheme.", REF2),
    ]
    @eval begin
        @doc generic_solver_docstring(
            $Description,
            $(string(Alg)),
            "Semilinear ODE solver",
            $Ref,
            """
            - `m`: Controls the size of Krylov subspace.
            - `iop`: If not zero, determines the length of the incomplete orthogonalization procedure (IOP).
                Note that if the linear operator/Jacobian is hermitian, then the Lanczos algorithm will always be used and the IOP setting is ignored.
            """,
            """
            m = 30,
            iop = 0,
            """
        )
        struct $Alg{CS, AD, FDT, ST, CJ} <:
            OrdinaryDiffEqAdaptiveExponentialAlgorithm{CS, AD, FDT, ST, CJ}
            m::Int
            iop::Int
            autodiff::AD
        end
    end
    @eval function $Alg(;
            m = 30, iop = 0, autodiff = AutoForwardDiff(), standardtag = Val{true}(),
            concrete_jac = nothing, chunk_size = Val{0}(),
            diff_type = Val{:forward}()
        )
        AD_choice, chunk_size,
            diff_type = _process_AD_choice(
            autodiff, chunk_size, diff_type
        )

        return $Alg{
            _unwrap_val(chunk_size), typeof(AD_choice),
            diff_type, _unwrap_val(standardtag),
            _unwrap_val(concrete_jac),
        }(
            m,
            iop,
            AD_choice
        )
    end
end

REF3 = """
Hochbruck, M., Lubich, C., & Selhofer, H. (1998). Exponential integrators for large systems of differential equations. SIAM Journal on Scientific Computing, 19(5), 1552-1574. (https://doi.org/10.1137/S1064827595295337)
"""

REF4 = """
Rainwater, G., & Tokman, M. (2016). A new approach to constructing efficient stiffly accurate EPIRK methods. Journal of Computational Physics, 323, 283-309. (https://doi.org/10.1016/j.jcp.2016.07.026)
"""
REF5 = """
Tokman, M., Loffeld, J., & Tranquilli, P. (2012). New Adaptive Exponential Propagation Iterative Methods of Runge--Kutta Type. SIAM Journal on Scientific Computing, 34(5), A2650-A2669. (https://doi.org/10.1137/110849961)
"""

for (Alg, Description, Ref) in [
        (:Exp4, "4th order EPIRK scheme.", REF3)
        (
            :EPIRK4s3A,
            "4th order EPIRK scheme with stiff order 4.", REF4,
        )
        (
            :EPIRK4s3B,
            "4th order EPIRK scheme with stiff order 4.", REF4,
        )
        (
            :EPIRK5s3,
            "5th order “horizontal” EPIRK scheme with stiff order 5. Broken.",
            REF4,
        )
        (
            :EXPRB53s3,
            "5th order EPIRK scheme with stiff order 5.", REF4,
        )
        (:EPIRK5P1, "5th order EPIRK scheme", REF5)
        (:EPIRK5P2, "5th order EPIRK scheme", REF5)
    ]
    @eval begin
        @doc generic_solver_docstring(
            $Description,
            $(string(Alg)),
            "Semilinear ODE solver",
            $Ref,
            """
            - `adaptive_krylov`: Determines if the adaptive Krylov algorithm with timestepping of Neisen & Wright is used.
            - `m`: Controls the size of Krylov subspace.
                    - `iop`: If not zero, determines the length of the incomplete orthogonalization procedure (IOP).
                        Note that if the linear operator/Jacobian is hermitian, then the Lanczos algorithm will always be used and the IOP setting is ignored.
            """,
            """
            adaptive_krylov = true,
            m = 30,
            iop = 0,
            """
        )

        struct $Alg{CS, AD, FDT, ST, CJ} <:
            OrdinaryDiffEqExponentialAlgorithm{CS, AD, FDT, ST, CJ}
            adaptive_krylov::Bool
            m::Int
            iop::Int
            autodiff::AD
        end
    end
    @eval function $Alg(;
            adaptive_krylov = true, m = 30, iop = 0, autodiff = AutoForwardDiff(),
            standardtag = Val{true}(), concrete_jac = nothing,
            chunk_size = Val{0}(), diff_type = Val{:forward}()
        )
        AD_choice, chunk_size,
            diff_type = _process_AD_choice(
            autodiff, chunk_size, diff_type
        )

        return $Alg{
            _unwrap_val(chunk_size), typeof(AD_choice), diff_type,
            _unwrap_val(standardtag), _unwrap_val(concrete_jac),
        }(
            adaptive_krylov,
            m,
            iop,
            AD_choice
        )
    end
end

"""
ETD2: Exponential Runge-Kutta Method
Second order Exponential Time Differencing method (in development).
"""
struct ETD2 <:
    OrdinaryDiffEqExponentialAlgorithm{0, false, Val{:forward}, Val{true}, nothing} end

function isdtchangeable(
        alg::Union{
            LawsonEuler, NorsettEuler, ETDRK2, ETDRK3, ETDRK4, HochOst4, ETD2,
        }
    )
    return false
end # due to caching

alg_order(alg::LawsonEuler) = 1
alg_order(alg::NorsettEuler) = 1
alg_order(alg::ETDRK2) = 2
alg_order(alg::ETDRK3) = 3
alg_order(alg::ETDRK4) = 4
alg_order(alg::HochOst4) = 4
alg_order(alg::Exp4) = 4
alg_order(alg::EPIRK4s3A) = 4
alg_order(alg::EPIRK4s3B) = 4
alg_order(alg::EPIRK5s3) = 5
alg_order(alg::EPIRK5P1) = 5
alg_order(alg::EPIRK5P2) = 5
alg_order(alg::EXPRB53s3) = 5
alg_order(alg::ETD2) = 2
alg_order(alg::Exprb32) = 3
alg_order(alg::Exprb43) = 4

alg_adaptive_order(alg::Exprb32) = 2
alg_adaptive_order(alg::Exprb43) = 4

function DiffEqBase.prepare_alg(
        alg::ETD2,
        u0::AbstractArray,
        p, prob
    )
    return alg
end

fsal_typeof(alg::ETD2, rate_prototype) = ETD2Fsal{typeof(rate_prototype)}

ismultistep(alg::ETD2) = true
